% close all;

%% Config
N = numel(Grid);
delta = linspace(-.3,.3,N); %// define offsets to distinguish plots
width = .4; %// small width to avoid overlap
colormap default;
cmap = [34,139,34;160,82,45; 54,100,139]/255; %// colormap
MyLineStyles={'-';'--';':';'-.';'-'};
MyMarkerStyles={'none';'none';'none';'none';'O'};
% legWidth = 1.8; %// make room for legend

nres_total = sum(nres) + sum(nres_slope) ;

if ~exist('SameIDX', 'var')
    SameIDX             =~squeeze(isnan(HRimpf_bound(1,1,1,:,1)));
end
%% Compute percentiles if needed
% This would make the IQR the inner 68%, which is desirable
if ~exist('LM_PERCENTILES', 'var') || ~exist('ALT_LM_PERCENTILES', 'var') 
    PercentileList = [0 2.5 5 16 50 84 95 97.5 100];
    NoPercentiles = length(PercentileList);

%     error('take account of: (1) that restrictions bind for different horizons, (2) that there could be slope restrictions');
    
%     PastRestrictions = 0;
    LM_PERCENTILES = NaN(nvar+1, nres_total, nstep, 3, 2, NoPercentiles, nshocks); 
    ALT_LM_PERCENTILES = NaN(nvar+1, H, nstep, 3, 2, NoPercentiles, nshocks); 
    for ss=1:nshocks
        % 1st dim: all variables + sum of macro variables
        % 2nd dim: all IRF horizons
        % 3rd dim: SR, HR, Difference HR - SR
        % 4th dim: SR, HR, Difference HR - SR
        % 5th dim: upper and lower bound
        % 6th dim: Different percentiles

        for nn=1:nvar+1 % nvar+1: Average for all macro variables.
            for bb=1:2 % upper bound or lower bound
                for ii = 1:3 % ii=1: SR LM multipliers. ii=2: HR LM multipliers. ii=3: groundwork for difference between HR and SR
                    % introduce selection variables as a simple way to handle
                    % different moments / pull data
                    switch ii
                        case 1
                            SR_Multiple=1;
                            HR_Multiple=0;
                        case 2
                            SR_Multiple=0;
                            HR_Multiple=1;
                        case 3
                            SR_Multiple=-1;
                            HR_Multiple=1;
                    end;
                    % Pull "data" on lagrange multipliers. This is
                    % necessary for Matfile-data structures.
                    if nn>nvar % average across all macro variables
%                         LM_Mean_AnyR = nan(nvar,res_total_count,nstep, nshocks, 2); % 4th dimension: = 1: min, 2: max 
                        if exist('SR', 'var')
                            LM_DATA=nanmean(HR( 1:NoMacroVars, :, :, ss,:,bb)*HR_Multiple+SR( 1:NoMacroVars, :, :, ss,:, bb)*SR_Multiple,1);
                        else
                            LM_DATA=nanmean(LagrangeMultipliers.HR( 1:NoMacroVars, :, :, ss,:, bb)*HR_Multiple+LagrangeMultipliers.SR( 1:NoMacroVars, :, :, ss,:, bb)*SR_Multiple,1);
                        end;
                    else
                        if exist('SR', 'var')
                            LM_DATA=HR( nn, :, :, ss, :,bb)*HR_Multiple+SR( nn, :, :, ss,:, bb)*SR_Multiple;
                        else
                            LM_DATA=LagrangeMultipliers.HR( nn, :, :, ss,:, bb)*HR_Multiple+LagrangeMultipliers.SR( nn, :, :, ss,:, bb)*SR_Multiple;
                        end;
                    end;

%                     error('cannot simply sum here... need to take the varying horizo length into account')
%                     map_matrix;
                    % LM_PERCENTILES sums over restriction horizons
                    for mm = 1:nres_total
                        LM_PERCENTILES(nn, mm, :, ii, bb, :, ss) = reshape(prctile(squeeze(sum(reshape(squeeze(LM_DATA(:,logical(map_matrix(mm,:)),:,SameIDX)), [1, sum(map_matrix(mm,:)), nstep, sum(SameIDX)]),2)), PercentileList, 2), [1, 1, nstep, 1, 1, NoPercentiles]);
                    end;
%                     % ALT_LM_PERCENTILES sums over restriction types.
%                     These are implicit for the non-slope-restrictions,
%                     but currently not explicitly addressed / available.
%                     ALT_LM_PERCENTILES(nn, :, :, ii, bb, :, ss) = reshape(prctile(squeeze(sum(reshape(squeeze(LM_DATA(:,:,:,SameIDX)), [1, nres_total, H, nstep, sum(SameIDX)]),2)), PercentileList, 3), [1, H, nstep, 1, 1, NoPercentiles]);
                end;
            end
        end
%         PastRestrictions = PastRestrictions + res_shock_count(ss);
    end;
    clear LM_DATA;
end;
% %% plots over time
% for nn=1:nvar+1 % nvar+1: Average for all macro variables.
%     close all
%     for bb=1:2
%         for DO_DIFFERENCE=0:1
%             figure;
%         %     subplot(2,1,1)
%             hold on;
%             hndl=plot(squeeze(ALT_LM_PERCENTILES(nn,:,:,2+DO_DIFFERENCE,bb,5))', 'LineWidth', 3);
%             set(hndl,{'LineStyle'}, MyLineStyles(1:H), {'Marker'}, MyMarkerStyles(1:H))
%             ylabel('Lagrange multipliers (average)');xlabel(TimeLabel);box('on');grid('on');
%             set(gca,'XLim',[1 Plot_Horizon+1],'XTick',[0 MyXticks],'XTickLabel',cellstr(num2str(([1 MyXticks]-1)')),'FontSize',8);
%             set(findall(gcf, '-property', 'FontSize'), 'FontSize', FontSize, 'fontWeight', 'normal','FontName','Times New Roman')
%             set(findall(gcf,'type','axes'),'ycolor',GridRGB,'xcolor',GridRGB,'GridLineStyle','-','LineWidth',.5,'FontSize',FontSize)
%             if DO_SAVE
%                 if ~DO_DIFFERENCE
%                     print(gcf, '-depsc', '-r300',sprintf('%sTimeProfile_LMVariable_%d_Model%d_H%d_simple_Lvl%d' SameSuffix '.eps']',save_path_bound,nn, model_version,H,bb))
%                 else
%                     print(gcf, '-depsc', '-r300',sprintf('%sTimeProfile_LMVariable_%d_Model%d_H%d_simple_Diff%d' SameSuffix '.eps']',save_path_bound,nn, model_version,H,bb))
%                 end;
%             end;        
%         end
%     end
% end;
          
%% Box plots
hndl=ones(1,N);

ExpandPrctiles = zeros(200,nstep, nres_total );

for ss=1:nshocks
    for nn=1:nvar+1 % nvar+1: Average for all macro variables.
        for bb=1:2
            for DO_DIFFERENCE=0:1
                figure;
            %     subplot(2,1,1)
                hold on;
                CurrentLargeXlim=0;
                CurrentSmallXlim=-0.1;
    % Code for debugging -- should be obsolete
    %             if DO_DIFFERENCE
    %                 if nn>nvar
    %                     LM_DATA=nanmean(LagrangeMultipliers.HR( 1:NoMacroVars, :, :, :, bb)-LagrangeMultipliers.SR( 1:NoMacroVars, :, :, :, bb),1);
    %                 else
    %                     LM_DATA=LagrangeMultipliers.HR( nn, :, :, :, bb)-LagrangeMultipliers.SR( nn, :, :, :, bb);
    %                 end;
    %             else
    %                 if nn>nvar
    %                     LM_DATA=nanmean(LagrangeMultipliers.HR( 1:NoMacroVars, :, :, :, bb),1);
    %                 else
    %                     LM_DATA=LagrangeMultipliers.HR( nn, :, :, :, bb);
    %                 end;
    %             end;
    %             LM_DATA=LM_DATA(:,:,:,find(SameIDX),:);
                for hh=1:nstep
    %                 for mm=1:nres_total
    %                 ExpandPrctiles(1,hh,:) = LM_PERCENTILES(nn, :, hh,2+DO_DIFFERENCE, bb, 1);
        %             ExpandPrctiles(ceil(PercentileList(end)*200/100)+1:200,:) = repmat(LM_PERCENTILES(nn, :, 2+DO_DIFFERENCE, bb, NoPercentiles), [200-ceil(PercentileList(pp)*200) 1]);

                    % fill in the median: 99 values above and below

    %                 for pp = ceil(NoPercentiles/2)+1:NoPercentiles-1
                    for pp = 1:NoPercentiles-1
                        StartPos = max(1,ceil( PercentileList(pp)*200/100));
                        if pp==ceil(NoPercentiles/2)+1
                            StartPos = 102;
                        end;
                        EndPos = min(floor( PercentileList(pp+1)*200/100), 200-1);
                        ExpandPrctiles(StartPos : EndPos,hh,:) = reshape( repmat(LM_PERCENTILES(nn, :, hh, 2+DO_DIFFERENCE, bb, pp, ss), [EndPos-StartPos+1, 1,1]), [EndPos-StartPos+1, 1,nres_total]);
                    end
                    ExpandPrctiles([100 101],hh,:) = reshape(repmat(LM_PERCENTILES(nn, :, hh, 2+DO_DIFFERENCE, bb, round(NoPercentiles+1)/2, ss), [2, 1,1]), [2, 1,nres_total]);
                    ExpandPrctiles(end-2:end,hh,:) = reshape(repmat(LM_PERCENTILES(nn, :, hh, 2+DO_DIFFERENCE, bb, NoPercentiles, ss), [3,1,1]), [3, 1,nres_total]);

    %                 ControlRes=randsample(nres_total,1);
        %             ExpandPrctiles(:,4,ControlRes)'
        %             squeeze( LM_PERCENTILES(nn, 4,ControlRes, 2+DO_DIFFERENCE, bb, :) )
                    if norm( prctile(squeeze(ExpandPrctiles(:,hh,:)), PercentileList,1)-squeeze( LM_PERCENTILES(nn, :,hh, 2+DO_DIFFERENCE, bb, :,ss) )'  )>1e-8
                        error('error expanding percentiles for custom plotting');
                    end;
                end;
                ii=2;%// better not to shadow i (imaginary unit)
                %     if ii~=ceil(N/2)
                %        labels = repmat({''},1,nres_total); %// empty labels
                %     else
                        labels = BoxPlotLabels; %// center plot: use real labels
                %     end
                %     boxplot(squeeze(sum(reshape(squeeze(LM_DATA(:,:,Grid(ii),:)), [nres_total, H, sum(SameIDX)]),2))','Color', cmap(ceil(ii*length(cmap)/length(Grid)),:), 'boxstyle','filled', ...
                %         'position',(1:nres_total)+delta(ii), 'widths',width, 'labels', labels, 'orientation', 'horizontal', 'Symbol', 'o');
    %                 hndl=boxplot(squeeze(sum(reshape(squeeze(LM_DATA(:,:,Grid(ii),SameIDX)), [nres_total, H, sum(SameIDX)]),2))','Color', cmap(floor(ii*length(cmap)/length(Grid)),:), 'boxstyle','filled', ...
    %                     'position',(nres_total:-1:1)+delta(4-ii), 'widths',width*1.5, 'labels', labels, 'orientation', 'horizontal', 'Symbol', 'o');
    %                     %// plot filled boxes with specified positions, widths, labels
    %                 hold all;
                    hndl=boxplot(squeeze(ExpandPrctiles(:,Grid(ii),:)),'Color', cmap(floor(ii*length(cmap)/length(Grid)),:), 'boxstyle','filled', ...
                        'position',(nres_total:-1:1)+delta(4-ii), 'widths',width*1.5, 'labels', labels, 'orientation', 'horizontal', 'Symbol', 'o');
                        %// plot filled boxes with specified positions, widths, labels
                    hold all;

                    Extremes=prctile(squeeze(ExpandPrctiles(:,Grid(ii),:))',[2.5 97.5],2);
                    IQR=prctile(squeeze(ExpandPrctiles(:,Grid(ii),:))',[25 75],2);
                    Median=prctile(squeeze(ExpandPrctiles(:,Grid(ii),:))',50,2);                
    % Code for debugging -- should be obsolete
    %                 Extremes=prctile(squeeze(sum(reshape(squeeze(LM_DATA(:,:,Grid(ii),SameIDX)),[nres_total,H,1,sum(SameIDX)]),2)),[2.5 97.5],2);
    %                 Median=prctile(squeeze(sum(reshape(squeeze(LM_DATA(:,:,Grid(ii),SameIDX)),[nres_total,H,1,sum(SameIDX)]),2)),50,2);

    %                 [idx1, idx2, idx3, idx4, idx5, idx6]=ind2sub(size(LM_PERCENTILES), find(LM_PERCENTILES==Median(2),1));
    %                 [jdx1, jdx2, jdx3]=ind2sub(size(ExpandPrctiles), find(ExpandPrctiles==Median(2),1));
    %                 display([idx2, idx3]);
    %                 display([jdx2, jdx3]);
    %                 [idx1, idx2, idx3, idx4, idx5, idx6]=ind2sub(size(LM_PERCENTILES), find(LM_PERCENTILES==Median(3),1));
    %                 [jdx1, jdx2, jdx3]=ind2sub(size(ExpandPrctiles), find(ExpandPrctiles==Median(3),1));
    %                 display([idx2, idx3]);
    %                 display([jdx2, jdx3]);
    % 
    %                 [idx1, idx2, idx3, idx4, idx5, idx6]=ind2sub(size(LM_PERCENTILES), find(LM_PERCENTILES==Extremes(1,2)));
    %                 [jdx1, jdx2, jdx3]=ind2sub(size(ExpandPrctiles), find(ExpandPrctiles==Extremes(1,2),1));
    %                 display([idx2, idx3]);
    %                 display([jdx2, jdx3]);
    %                 
    %                 [idx1, idx2, idx3, idx4, idx5, idx6]=ind2sub(size(LM_PERCENTILES), find(LM_PERCENTILES==Extremes(3,2)));
    %                 [jdx1, jdx2, jdx3]=ind2sub(size(ExpandPrctiles), find(ExpandPrctiles==Extremes(3,2),1));
    %                 display([idx2, idx3]);
    %                 display([jdx2, jdx3]);
    % 
    %                 fprintf(2, 'is the problem that Grid(ii)==9, but idx2==14?\n')
    %                 error('debug first');
                    scatter(Extremes(:,1), (nres_total:-1:1)+delta(4-ii),   30,'o','MarkerEdgeColor', cmap(floor(ii*length(cmap)/length(Grid)),:))
                    scatter(Extremes(:,2), (nres_total:-1:1)+delta(4-ii),   30,'o','MarkerEdgeColor', cmap(floor(ii*length(cmap)/length(Grid)),:))
                    scatter(Median, (nres_total:-1:1)+delta(4-ii),   50,'+','MarkerEdgeColor', cmap(floor(ii*length(cmap)/length(Grid)),:), 'LineWidth', 2)
                    hndl(ii)=plot(NaN,1,'color', cmap(floor(ii*length(cmap)/length(Grid)),:), 'LineWidth', 3); %// dummy plot for legend
                    CurrentLargeXlim = max(CurrentLargeXlim, max(abs(Extremes(:,3-bb))));
                    CurrentSmallXlim = min(CurrentSmallXlim, max(abs(Extremes(:,bb))*sign(min(Extremes(:,bb)))) );
    %             end
                delete(findobj(gca,'tag','Outliers'));
                delete(findobj(gca,'tag','Whisker'));            
                MedianHndl=findobj(gca,'tag','Median');
                MedianLimits=cell2mat(get(MedianHndl,'XData'));
                CurrentLargeXlim = max(CurrentLargeXlim, max(abs(MedianLimits(:,3-bb))));
                CurrentSmallXlim = min(CurrentSmallXlim, max(abs(MedianLimits(:,bb)))*sign(min(MedianLimits(:,bb))));

                set(gca,'TickLabelInterpreter', 'tex');
                if ~DO_DIFFERENCE
                    xlabel('Lagrange multipliers'); grid on;
                else
                    xlabel('Difference in Lagrange multipliers'); grid on;
                end;
                xlim(sort([floor(5*CurrentSmallXlim)/5 ceil(CurrentLargeXlim*5)/5]*sign(1.5-bb)))
                if NoMacroRes{ss}<nvar
                    plot(xlim, nres_total-(NoMacroRes{ss}*[1,1]+0.5)+1, '--k')
                    for uu=2:nshocks
                        plot(xlim, nres_total-(sum(nres(1:uu-1)+nres_slope(1:uu-1))*[1,1]+0.5)+1, '-k')
                    end;
                    if any(TFP_Lambda>0)
                        plot(xlim, length(TFP_Lambda)*[1 1]+0.5, '--k')
                    end;
                    ylim([0.5 nres_total+0.5])
                    if bb==1
                        text(max(xlim)-0.05, nres_total-(NoMacroRes{ss}+0.5)+1, 'Macro restrictions', 'VerticalAlignment', 'bottom', 'HorizontalAlignment', 'Right');
                        text(max(xlim)-0.05, nres_total-(NoMacroRes{ss}+0.5)+1, 'Micro restrictions', 'VerticalAlignment', 'top', 'HorizontalAlignment', 'Right');
                        if any(TFP_Lambda>0)
                            text(max(xlim)-0.05, length(TFP_Lambda)+0.5, 'Macro HR', 'VerticalAlignment', 'top', 'HorizontalAlignment', 'Right');
                        end;
                    else
                        text(min(xlim)+0.05, nres_total-(NoMacroRes{ss}+0.5)+1, 'Macro restrictions', 'VerticalAlignment', 'bottom', 'HorizontalAlignment', 'Left');
                        text(min(xlim)+0.05, nres_total-(NoMacroRes{ss}+0.5)+1, 'Micro restrictions', 'VerticalAlignment', 'top', 'HorizontalAlignment', 'Left');
                        if any(TFP_Lambda>0)
                            text(min(xlim)+0.05, length(TFP_Lambda)+0.5, 'Macro HR', 'VerticalAlignment', 'top', 'HorizontalAlignment', 'Left');
                        end;
                    end;
                else
                    ExtraAdjustment = 0;
                    for uu=1:nshocks
                        plot(xlim, nres_total-(nres_slope(ss)*[1,1]+0.5+ExtraAdjustment ), '--k')
                        ylim([0.5 nres_total+0.5])
                        if bb==1
                            text(max(xlim)-0.05, nres_total-(nres_slope(ss)+0.5+ExtraAdjustment ), 'Slope restrictions', 'VerticalAlignment', 'top', 'HorizontalAlignment', 'Right');
                        else
                            text(min(xlim)+0.05, nres_total-(nres_slope(ss)+0.5+ExtraAdjustment ), 'Slope restrictions', 'VerticalAlignment', 'top', 'HorizontalAlignment', 'Left');
                        end;
                        ExtraAdjustment = nres(uu) + nres_slope(uu) + ExtraAdjustment ;
                    end;
                end;
                for uu=1:nshocks-1
                    plot(xlim, nres_total*[1,1]-((sum(nres_slope(1:uu))+sum(nres(1:uu))))+0.5, '-k');
%                     disp(nres_total-((sum(nres_slope(1:uu))+sum(nres(1:uu))))-0.5);
                end;
                % xlim([1+2*delta(1) nres_total+legWidth+2*delta(nres_total)]) %// adjust x limits, with room for legend
    %             legend(hndl,legendEntries, 'Location', 'Best');
    %             legend('boxoff')
                set(findall(gcf, '-property', 'FontSize'), 'FontSize', 14, 'fontWeight', 'normal','FontName','Times New Roman');
                set(gca, 'XMinorGrid', 'on')
                if DO_SAVE
                    if ~DO_DIFFERENCE
                        print(gcf, '-depsc', '-r300',sprintf(['%sLMVariable_%d_Model%d_H%d_simple_Lvl%d_s%d' SameSuffix '.eps']',save_path_bound,nn, model_version,H,bb, ss))
                    else
                        print(gcf, '-depsc', '-r300',sprintf(['%sLMVariable_%d_Model%d_H%d_simple_Diff%d_s%d' SameSuffix '.eps']',save_path_bound,nn, model_version,H,bb, ss))
                    end;
                end;

                close all;
                for ii=1:3 %// better not to shadow i (imaginary unit)
                %     if ii~=ceil(N/2)
                %        labels = repmat({''},1,nres_total); %// empty labels
                %     else
                        labels = BoxPlotLabels; %// center plot: use real labels
                %     end
                %     boxplot(squeeze(sum(reshape(squeeze(LM_DATA(:,:,Grid(ii),:)), [nres_total, H, sum(SameIDX)]),2))','Color', cmap(ceil(ii*length(cmap)/length(Grid)),:), 'boxstyle','filled', ...
                %         'position',(1:nres_total)+delta(ii), 'widths',width, 'labels', labels, 'orientation', 'horizontal', 'Symbol', 'o');
                    hndl=boxplot(squeeze(ExpandPrctiles(:,Grid(ii),:)),'Color', cmap(floor(ii*length(cmap)/length(Grid)),:), 'boxstyle','filled', ...
                        'position',(nres_total:-1:1)+delta(4-ii), 'widths',width*1.5, 'labels', labels, 'orientation', 'horizontal', 'Symbol', 'o');
                        %// plot filled boxes with specified positions, widths, labels
                    hold all;

                    Extremes=prctile(squeeze(ExpandPrctiles(:,Grid(ii),:))',[2.5 97.5],2);
                    Median=prctile(squeeze(ExpandPrctiles(:,Grid(ii),:))',50,2);                
                    scatter(Extremes(:,1), (nres_total:-1:1)+delta(4-ii),   30,'o','MarkerEdgeColor', cmap(floor(ii*length(cmap)/length(Grid)),:))
                    scatter(Extremes(:,2), (nres_total:-1:1)+delta(4-ii),   30,'o','MarkerEdgeColor', cmap(floor(ii*length(cmap)/length(Grid)),:))
                    scatter(Median, (nres_total:-1:1)+delta(4-ii),   50,'+','MarkerEdgeColor', cmap(floor(ii*length(cmap)/length(Grid)),:), 'LineWidth', 2)
                    hndl(ii)=plot(NaN,1,'color', cmap(floor(ii*length(cmap)/length(Grid)),:), 'LineWidth', 3); %// dummy plot for legend
                    CurrentLargeXlim = max(CurrentLargeXlim, max(abs(Extremes(:,3-bb))));
                    CurrentSmallXlim = min(CurrentSmallXlim, max(abs(Extremes(:,bb)))*sign(min(Extremes(:,bb))) );
                end
                delete(findobj(gca,'tag','Outliers'));
                delete(findobj(gca,'tag','Whisker'));            
                MedianHndl=findobj(gca,'tag','Median');
                MedianLimits=cell2mat(get(MedianHndl,'XData'));
                CurrentLargeXlim = max(CurrentLargeXlim, max(abs(MedianLimits(:,3-bb))));
                CurrentSmallXlim = min(CurrentSmallXlim, max(abs(MedianLimits(:,bb)))*sign(min(MedianLimits(:,bb))));

                set(gca,'TickLabelInterpreter', 'tex');
                if ~DO_DIFFERENCE
                    xlabel('Lagrange multipliers'); grid on;
                else
                    xlabel('Difference in Lagrange multipliers'); grid on;
                end;
                xlim(sort([floor(5*CurrentSmallXlim)/5 ceil(CurrentLargeXlim*5)/5]*sign(1.5-bb)))
                plot(xlim, nres_total-(NoMacroRes{ss}*[1,1]+0.5)+1, '--k')
                for uu=2:nshocks
                    plot(xlim, nres_total-(sum(nres(1:uu-1)+nres_slope(1:uu-1))*[1,1]+0.5)+1, '-k')
                end;
                if any(TFP_Lambda>0)
                    plot(xlim, length(TFP_Lambda)*[1 1]+0.5, '--k')
                end;
                ylim([0.5 nres_total+0.5])
                if bb==1
                    text(max(xlim)-0.05, nres_total-(NoMacroRes{ss}+0.5)+1, 'Macro restrictions', 'VerticalAlignment', 'bottom', 'HorizontalAlignment', 'Right');
                    text(max(xlim)-0.05, nres_total-(NoMacroRes{ss}+0.5)+1, 'Micro restrictions', 'VerticalAlignment', 'top', 'HorizontalAlignment', 'Right');
                    if any(TFP_Lambda>0)
                        text(max(xlim)-0.05, length(TFP_Lambda)+0.5, 'Macro HR', 'VerticalAlignment', 'top', 'HorizontalAlignment', 'Right');
                    end;
                else
                    text(min(xlim)+0.05, nres_total-(NoMacroRes{ss}+0.5)+1, 'Macro restrictions', 'VerticalAlignment', 'bottom', 'HorizontalAlignment', 'Left');
                    text(min(xlim)+0.05, nres_total-(NoMacroRes{ss}+0.5)+1, 'Micro restrictions', 'VerticalAlignment', 'top', 'HorizontalAlignment', 'Left');
                    if any(TFP_Lambda>0)
                        text(min(xlim)+0.05, length(TFP_Lambda)+0.5, 'Macro HR', 'VerticalAlignment', 'top', 'HorizontalAlignment', 'Left');
                    end;
                end;
                % xlim([1+2*delta(1) nres_total+legWidth+2*delta(nres_total)]) %// adjust x limits, with room for legend
    %             legend(hndl,legendEntries, 'Location', 'Best');
    %             legend('boxoff')
                set(findall(gcf, '-property', 'FontSize'), 'FontSize', 14, 'fontWeight', 'normal','FontName','Times New Roman');
                if DO_SAVE
                    if ~DO_DIFFERENCE
                        print(gcf, '-depsc', '-r300',sprintf(['%sLMVariable_%d_Model%d_H%d_Lvl%d_s%d' SameSuffix '.eps']',save_path_bound,nn, model_version,H,bb,ss))
                    else
                        print(gcf, '-depsc', '-r300',sprintf(['%sLMVariable_%d_Model%d_H%d_Diff%d_s%d' SameSuffix '.eps']',save_path_bound,nn, model_version,H,bb,ss))
                    end;
                end;

            end;
    %         print('-depsc', 'Trial' SameSuffix '.eps']')
        end;
    end;
end;
close all;