close all;

%% Config
FontSize = 18;

GridRGB = [0 0 0]+.3;

RGB     = [.7 .7 .7]+.2;        RGB_E   = 'none';
SRRGB   = [255,160,122]/255;    SRRGB_E = 'none';
SR_RGB  = [139,  0,  0;
    220, 20, 60;
    240,128,128]/255;
HR_RGB  = [  0,  0,139;
    65,105,225;
    135,206,235]/255;
HRRGB   = [220, 20, 60]/255;    HRRGB_E = 'none';

colormap default;
Diff_RGB= [34,139,34;160,82,45; 54,100,139]/255; %// colormap

% Diff_RGB  = (SR_RGB+HR_RGB)/2;

IS_HRRGB   = [  0,191,255]/255;
IS_SRRGB   = [240,128,128]/255;

tmpa = [1:nstep nstep:-1:1]';

DataTables=cell(2,1);
DataTables{1}=cell(NoMacroVars,3);
DataTables{2}=cell(nvar-NoMacroVars,3);
%%
% Plot in differences under Alg 1
close all;

% this code is written assuming the FEVD is performed for all nvar variables 
% and all nstep horizons
for mm=1:nvar
    
    % Figure
    figure(mm);
    set(gcf, 'name', IncludeSeriesNames{mm});
    % middle "1": 1st shock. Could, in principle, vary
    Diff_FEVD = 100*prctile(squeeze(ResultsAll.SR_FEVD_bound(mm,:,1,:,2))-squeeze(ResultsAll.HR_FEVD_bound(mm,:,1,:,2)), [5 16 50 68 95],2);
    SR_FEVD   = 100*prctile(squeeze(ResultsAll.SR_FEVD_bound(mm,:,1,:,2)), [5 16 50 68 95],2);
    HR_FEVD   = 100*prctile(squeeze(ResultsAll.HR_FEVD_bound(mm,:,1,:,2)), [5 16 50 68 95],2);

    tmpSR = [Diff_FEVD(:,2) ; flipdim( Diff_FEVD(:,4) ,1)];
    g = patch(tmpa,tmpSR,RGB(1,:),'edgecolor',RGB_E,'HandleVisibility','on','LineWidth',2);
    % tmpSR = [Diff_FEVD(:,2) ; flipdim( Diff_FEVD(:,4) ,1)];
    % g = patch(tmpa,tmpSR,RGB,'edgecolor',RGB_E,'HandleVisibility','on','LineWidth',2);
    hold all;
    hndl_outer=plot(1:nstep, Diff_FEVD(:,[2 4]), '-', 'LineWidth',1, 'Color', ones(1,3)/3);
    % set(g, 'edgecolor', ones(1,3)/3); % color the edges dark gray for better visibility
    hndl=plot(1:nstep, [SR_FEVD(:,3), HR_FEVD(:,3), Diff_FEVD(:,3)]);
    set(hndl, {'LineWidth'},{4;4;2}, {'Color'},{SR_RGB(1,:);HR_RGB(1,:);[0 0 0]});
    tmp_lim = [1 nstep 0 1];
    ylabel('max explained FEV (% of total)');
    xlabel(TimeLabel);box('on');
    set(gca,'XLim',[1 Plot_Horizon+1],'XTick',[0 MyXticks],'XTickLabel',cellstr(num2str(([1 MyXticks]-1)')),'YLim',[0 100],'FontSize',8);
    set(findall(gcf, '-property', 'FontSize'), 'FontSize', FontSize, 'fontWeight', 'normal','FontName','Times New Roman')
    set(findall(gcf,'type','axes'),'ycolor',GridRGB,'xcolor',GridRGB,'GridLineStyle','-','LineWidth',.5,'FontSize',FontSize)
    grid on;
    if DO_SAVE
        print(gcf, '-depsc', '-r300',sprintf('%sFEVD_%d_Model%1.0f_H%d_Robust.eps',save_path_bound,mm, model_version,H))
    end
    
    % Table
    if mm<=NoMacroVars
        TableID=1;
        TableName='Macro';
    else
        TableID=2;
        TableName='Micro';
    end
    DataTables{TableID}(mm,1)=cellstr([IncludeSeriesNames{mm}, num2str(reshape(SR_FEVD(:,[3 2 4])', [1, nstep*3]), '& %1.0f (%1.0f,%1.0f)'), '\\']);
    DataTables{TableID}(mm,2)=cellstr([IncludeSeriesNames{mm}, num2str(reshape(HR_FEVD(:,[3 2 4])', [1, nstep*3]), '& %1.0f (%1.0f,%1.0f)'), '\\']);
    DataTables{TableID}(mm,3)=cellstr([IncludeSeriesNames{mm}, num2str(reshape(Diff_FEVD(:,[3 2 4])', [1, nstep*3]), '& %1.0f (%1.0f,%1.0f)'), '\\']);
    if any(mm==[NoMacroVars, nvar])
        if DO_SAVE
            for tt=1:3
                my_fid = fopen( sprintf('%sFEVD_Model%1.0f_H%d_%s_Robust_Tab%d.tex',save_path_bound, model_version,H,TableName,tt), 'w');
                WriteTable=DataTables{TableID}(:,tt);
                fprintf(my_fid, '%s \n', WriteTable{:});
                fclose(my_fid);
            end
        end
    end
end

%%
% Plot Alg 2
close all;
DO_68=true;
for mm=1:nvar
    figure(mm);
    set(gcf, 'name', IncludeSeriesNames{mm});
    % Here: hard-wired that this is for the first shock. Could be relaxed.
    Diff68_FEVD = 100*prctile(reshape(prctile(ResultsAll.SR_FEVD_bound_q(mm,:,1,:,:),68,5)-prctile(ResultsAll.HR_FEVD_bound_q(mm,:,1,:,:),68,5), [nstep, ndraws]), [5 16 50 68 95],2);
    Diff16_FEVD = 100*prctile(reshape(prctile(ResultsAll.SR_FEVD_bound_q(mm,:,1,:,:),16,5)-prctile(ResultsAll.HR_FEVD_bound_q(mm,:,1,:,:),16,5), [nstep, ndraws]), [5 16 50 68 95],2);
    SR_FEVD   = 100*prctile(reshape(ResultsAll.SR_FEVD_bound_q(mm,:,1,:,:), [nstep, ndraws*ndraws_q]), [5 16 50 68 95],2);
    HR_FEVD   = 100*prctile(reshape(ResultsAll.HR_FEVD_bound_q(mm,:,1,:,:), [nstep, ndraws*ndraws_q]), [5 16 50 68 95],2);

    if ~DO_68
        tmpSR = [HR_FEVD(:,1) ; flipdim( HR_FEVD(:,5) ,1)];
        g = patch(tmpa,tmpSR,HR_RGB(1,:),'edgecolor',RGB_E,'HandleVisibility','on','LineWidth',2);
        tmpSR = [HR_FEVD(:,2) ; flipdim( HR_FEVD(:,4) ,1)];
        g = patch(tmpa,tmpSR,RGB,'edgecolor',RGB_E,'HandleVisibility','on','LineWidth',2);
        hold all;
        hndl_outer=plot(1:nstep, HR_FEVD(:,[2 4]), '-', 'LineWidth',1, 'Color', ones(1,3)/3);
        % set(g, 'edgecolor', ones(1,3)/3); % color the edges dark gray for better visibility
        hndl=plot(1:nstep, [SR_FEVD(:,1:5), HR_FEVD(:,3)]);
        set(hndl, {'LineWidth'},{4;4;4;4;4;4}, {'Color'},{SR_RGB(3,:);SR_RGB(2,:);SR_RGB(1,:);SR_RGB(2,:);SR_RGB(3,:);HR_RGB(1,:)});
        set(hndl([1 2 3 4 5]), {'LineStyle'},{':';'--';'-.';'--';':'});
    else
        tmpSR = [HR_FEVD(:,2) ; flipdim( HR_FEVD(:,4) ,1)];
        g = patch(tmpa,tmpSR,HR_RGB(3,:),'edgecolor',HR_RGB(3,:),'HandleVisibility','on','LineWidth',2);
        hold all;
        hndl_outer=plot(1:nstep, HR_FEVD(:,[2 4]), '-', 'LineWidth',1, 'Color', ones(1,3)/3);
        hndl=plot(1:nstep, SR_FEVD(:,[2 4]));
        set(hndl, {'LineWidth'},{4;4}, {'Color'},{SR_RGB(2,:);SR_RGB(2,:)});
        set(hndl([1 2  ]), {'LineStyle'},{':';':'});
    end
    tmp_lim = [1 nstep 0 1];
    ylabel('explained FEV (% of total)');
    xlabel(TimeLabel);box('on');
    set(gca,'XLim',[1 Plot_Horizon+1],'XTick',[0 MyXticks],'XTickLabel',cellstr(num2str(([1 MyXticks]-1)')),'FontSize',8);
    set(findall(gcf, '-property', 'FontSize'), 'FontSize', FontSize, 'fontWeight', 'normal','FontName','Times New Roman')
    set(findall(gcf,'type','axes'),'ycolor',GridRGB,'xcolor',GridRGB,'GridLineStyle','-','LineWidth',.5,'FontSize',FontSize)
    grid on;
    
    if DO_SAVE
        print(gcf, '-depsc', '-r300',sprintf('%sFEVD_%d_Model%1.0f_H%d_Bayes.eps',save_path_bound,mm, model_version,H))
    end
    
    % Table
    if mm<=NoMacroVars
        TableID=1;
        TableName='Macro';
    else
        TableID=2;
        TableName='Micro';
    end
    DataTables{TableID}(mm,1)=cellstr([IncludeSeriesNames{mm}, num2str(reshape(SR_FEVD(:,[2 4])', [1, nstep*2]), '& (%1.0f,%1.0f)'), '\\']);
    DataTables{TableID}(mm,2)=cellstr([IncludeSeriesNames{mm}, num2str(reshape(HR_FEVD(:,[2 4])', [1, nstep*2]), '& (%1.0f,%1.0f)'), '\\']);
    DataTables{TableID}(mm,3)=cellstr([IncludeSeriesNames{mm}, num2str(reshape(Diff68_FEVD(:,[3 2 4])', [1, nstep*3]), '& %1.0f (%1.0f,%1.0f)'), '\\']);
    DataTables{TableID}(mm,4)=cellstr([IncludeSeriesNames{mm}, num2str(reshape(Diff16_FEVD(:,[3 2 4])', [1, nstep*3]), '& %1.0f (%1.0f,%1.0f)'), '\\']);
    if any(mm==[NoMacroVars, nvar])
        if DO_SAVE
            for tt=1:4
                my_fid = fopen( sprintf('%sFEVD_Model%1.0f_H%d_%s_Bayes_Tab%d.tex',save_path_bound, model_version,H,TableName,tt), 'w');
                WriteTable=DataTables{TableID}(:,tt);
                fprintf(my_fid, '%s \n', WriteTable{:});
                fclose(my_fid);
            end
        end
    end 
end
