* Re-do of industry level RnD intensity computations
* Thorsten Drautzburg, 12/30/2019

clear all

* cd YOUR_REP_FILE_FOLDER

* Compustat data
import delimited using E:\WRDS\f2bd0c1cc056c516.csv
* Required variables: fic xrdp xrd sale at gvkey fyear oibdp xlr sic 


* clean the data
keep if fic=="USA" // US headquarters
keep if xrdp>=0  // non-negative R&D
keep if xrd>=0   // non-negative R&D
keep if sale>0   // positive net sales
keep if at>0	 // positive assets 
// take care of overlapping fiscal years
ge flag= (gvkey==gvkey[_n-1] & fyear==fyear[_n-1]) 
ge xflag= (gvkey==gvkey[_n-1] & fyear==fyear[_n-1]) & xrd~=xrd[_n-1]
assert xflag==0
drop xflag
ge xflag= (gvkey==gvkey[_n-1] & fyear==fyear[_n-1]) & xrdp~=xrdp[_n-1]
assert xflag==0
drop xflag
ge iflag= (gvkey==gvkey[_n-1] & fyear==fyear[_n-1]) & oibdp~=oibdp[_n-1]
assert iflag==0
drop iflag
collapse (first) xrd* oi* sic at sale xlr , by(gvkey fyear) fast

tsset gvkey fyear
* moving averages
ge ma_inv = (oibdp+l.oibdp+l2.oibdp+l3.oibdp+l4.oibdp)/5
ge ma_at = (at+l.at+l2.at+l3.at+l4.at)/5
count if ma_inv<0 
ge xrd_inc = xrd/l.ma_inv if l.ma_inv>0
ge xrd_asset = xrd/l.ma_at
ge xrdp_inc = xrdp/l.ma_inv if l.ma_inv>0
ge xrdp_asset = xrdp/l.ma_at

do ge_ff5
bysort ff5: sum xrd*_asset 
bysort ff5: sum xrd*_inc
 

ge ratio=at/ma_inv 
sum ratio if ma_inv>0 & xrd_inc~=.
capture drop scaled_xrd_asset
ge scaled_xrd_asset=xrd_asset
graph box xrd_asset, over(ff5)  nooutsides ///
	bgcolor(white)  graphregion(color(white)) ytitle("scaled R&D") 
	
	
graph export Graphs\ff5_rnd_assets.eps, mag(200) replace 

graph box xrd_inc , over(ff5)  nooutsides ///
	bgcolor(white)  graphregion(color(white)) ytitle("scaled R&D") 
	
graph export Graphs\ff5_rnd_inc.eps, mag(200) replace 
