% Simplified code from IdentificationGivenReducedForm_Inner_Knitro: Only
% checks if feasible points can be found
SRestrictionsA = cell(nshocks,1);
HRestrictionsA = cell(nshocks,1);

AnyR_rejected_draws = 0;

draw_i=0;
tic;
ChebychevFlag = zeros(ndraws+1, 2);
ChebychevR = zeros(ndraws+1, 2);
ChebychevNormX = zeros(ndraws+1, 2);

options = optimset('Display', 'off', 'Algorithm', 'active-set', 'TolCon', 1e-10, 'TolFun', 1e-10, 'TolX', 1e-10, 'MaxIter', 5e4, 'MaxFunEvals', 5e4 ) ;
warning('off', 'optim:linprog:WillRunDiffAlg')

if ~exist('DO_SLOPE_W_SR', 'var')
    DO_SLOPE_W_SR=true;
end

tic;
while (draw_i <= ndraws)
    biga = zeros(nvar*lags,nvar*lags);
    for j = 1:lags-1
        biga(j*nvar+1:nvar*(j+1),nvar*(j-1)+1:j*nvar) = eye(nvar);
    end
    if draw_i > 0
        for ii = 1:lags
            biga(1:nvar,(ii-1)*nvar+1:ii*nvar) = squeeze(By(:,:,ii,draw_i));
        end
        tmp_chol = chol(squeeze(omega(:,:,draw_i)),'lower');
    else
        for ii = 1:lags
            biga(1:nvar,(ii-1)*nvar+1:ii*nvar) = squeeze(mean(By(:,:,ii,:),4));
        end
        tmp_chol = chol(squeeze(mean(omega(:,:,:),3)),'lower');
    end
    
    res_total_count = 0;
    res_shock_count = cell(nshocks);
    for ss=1:nshocks
        res_shock_count{ss} = 0;
        for hh=H_min:H_max
            h_idx = H_bounds{ss}(:,1)<=hh & hh<=H_bounds{ss}(:,2);
            res_shock_count{ss} = res_shock_count{ss} + sum(h_idx);
            res_total_count = res_total_count + sum(h_idx);
        end
        res_shock_count{ss} = res_shock_count{ss} + nres_slope(ss);
        res_total_count = res_total_count + nres_slope(ss);
    end
    SRestrictions_combined = zeros(res_total_count,nvar*nshocks);
    b_combined = zeros(res_total_count,1);
    ones_combined = ones(nvar*nshocks,1);
    res_total_count = 0;
    for ss=1:nshocks
        SRestrictionsA{ss,1} =zeros(res_shock_count{ss},nvar);
        res_running_count = 0;
        for hh=H_min:H_max
            h_idx = H_bounds{ss}(:,1)<=hh & hh<=H_bounds{ss}(:,2);
            if hh>1
                SRestrictionsA{ss,1}(res_running_count+(1:sum(h_idx)),:)=  - (SS{ss,1}(h_idx,:)*EE{ss,1}*...
                    ( Do_CumulativeMatrix.*setup_irf(biga,tmp_chol,J,hh, 1)  + (1-Do_CumulativeMatrix).*setup_irf(biga,tmp_chol,J,hh, 0)) );
            else
                SRestrictionsA{ss,1}( 1:sum(h_idx) ,:)= - (SS{ss,1}(h_idx,:)*EE{ss,1}*tmp_chol);
            end
            res_running_count = res_running_count + sum(h_idx);
        end
        if DO_SLOPE_W_SR
            for nn=1:nres_slope(ss)
                SRestrictionsA{ss,1}(res_running_count+nn,:) = ...
                     -SS_slope{ss,1}(nn,:)*EE_slope{ss,1}*...
                           ( ( Do_CumulativeMatrix.*setup_irf(biga,tmp_chol,J,H_bounds_slope{ss}(nn,2), 1)  + (1-Do_CumulativeMatrix).*setup_irf(biga,tmp_chol,J,H_bounds_slope{ss}(nn,2), 0)) ...
                           - ( Do_CumulativeMatrix.*setup_irf(biga,tmp_chol,J,H_bounds_slope{ss}(nn,1), 1)  + (1-Do_CumulativeMatrix).*setup_irf(biga,tmp_chol,J,H_bounds_slope{ss}(nn,1), 0)) );
            end
        end
        res_running_count = res_running_count + nres_slope(ss);
        SRestrictions_combined( res_total_count  + (1:res_running_count ), (ss-1)*nvar+(1:nvar) ) = SRestrictionsA{ss,1};
        res_total_count = res_total_count + res_running_count;
    end
    
    AnyRestrictions_combined = SRestrictions_combined;
    AnyRestrictionsA = SRestrictionsA;
    
    %call innermost loop: Alg 2 and Alg 1 given parameters
    %call innermost loop: Alg 2 and Alg 1 given parameters
    [xfeasible, chebr, chebflag ] = recursive_chebycenter(SRestrictionsA, SRestrictions_combined);
    ChebychevR(draw_i+1,1)        = chebr;
    ChebychevFlag(draw_i+1,1)     = chebflag;
    ChebychevNormX(draw_i+1,1)    = norm(xfeasible);
    
    if ll~=0 || (~DO_SLOPE_W_SR && max(nres_slope)>0)
        % =====================================================================
        % Nummerical Bounds via Heterogeneity Restrictions
        % =====================================================================
        HRestrictions_combined = zeros(size(SRestrictions_combined ));
        ones_combined = ones(nvar*nshocks,1);
        res_total_count = 0;
        for ss=1:nshocks
            HRestrictionsA{ss,1} =zeros(res_shock_count{ss},nvar);
            res_running_count = 0;
            for hh=H_min:H_max
                h_idx = H_bounds{ss}(:,1)<=hh & hh<=H_bounds{ss}(:,2);
                if hh>1
                    HRestrictionsA{ss,1}(res_running_count+(1:sum(h_idx)),:)=  - (SS{ss,1}(h_idx,:)*(EE{ss,1}-LL_past_impact{ss,1})*...
                        ( Do_CumulativeMatrix.*setup_irf(biga,tmp_chol,J,hh, 1)  + (1-Do_CumulativeMatrix).*setup_irf(biga,tmp_chol,J,hh, 0)) );
                else
                    HRestrictionsA{ss,1}( 1:sum(h_idx) ,:)= - (SS{ss,1}(h_idx,:)*(EE{ss,1}-LL_past_impact{ss,1})*tmp_chol);
                end
                res_running_count = res_running_count + sum(h_idx);
            end
            for nn=1:nres_slope(ss)
                HRestrictionsA{ss,1}(res_running_count+nn,:) = ...
                     -SS_slope{ss,1}(nn,:)*EE_slope{ss,1}*...
                           ( ( Do_CumulativeMatrix.*setup_irf(biga,tmp_chol,J,H_bounds_slope{ss}(nn,2), 1)  + (1-Do_CumulativeMatrix).*setup_irf(biga,tmp_chol,J,H_bounds_slope{ss}(nn,2), 0)) ...
                           - ( Do_CumulativeMatrix.*setup_irf(biga,tmp_chol,J,H_bounds_slope{ss}(nn,1), 1)  + (1-Do_CumulativeMatrix).*setup_irf(biga,tmp_chol,J,H_bounds_slope{ss}(nn,1), 0)) );
            end
            res_running_count = res_running_count + nres_slope(ss);
            HRestrictions_combined( res_total_count  + (1:res_running_count ), (ss-1)*nvar+(1:nvar) ) = HRestrictionsA{ss,1};
            res_total_count = res_total_count + res_running_count;
        end
        
        AnyRestrictions_combined = HRestrictions_combined;
        AnyRestrictionsA = HRestrictionsA;
        %call innermost loop: Alg 2 and Alg 1 given parameters
        [xfeasible, chebr, chebflag ] = recursive_chebycenter(AnyRestrictionsA, AnyRestrictions_combined);
        ChebychevR(draw_i+1,2)        = chebr;
        ChebychevFlag(draw_i+1,2)     = chebflag;
        ChebychevNormX(draw_i+1,2)    = norm(xfeasible);
        
    end
    if any(ChebychevFlag(draw_i+1,:)~=1 & ChebychevFlag(draw_i+1,:)~=3)
        fprintf(2,'x ');
    end
        
    if mod(draw_i,1)==0;fprintf('Identification for draw:\t%5.0f (%5.2f minutes)\n',draw_i,toc/60);end
    draw_i=draw_i+1;

end

% warning('on')
disp('Posterior mean: satisfied sufficient condition');
disp((ChebychevFlag(1,:)==1));
disp('Posterior mean: satisfied sufficient condition or fmincon solution');
disp((ChebychevFlag(1,:)==1) + (ChebychevFlag(1,:)==3));
disp('Posterior mean: satisfied necessary condition and without fmincon solution');
disp((ChebychevFlag(1,:)==2));


disp('draws with satisfied sufficient condition');
disp(sum(ChebychevFlag(2:end,:)==1,1));
disp('draws with satisfied sufficient condition or fmincon solution');
disp(sum(ChebychevFlag(2:end,:)==1,1)+sum(ChebychevFlag(2:end,:)==3,1));
disp('draws with satisfied necessary condition and without fmincon solution');
disp(sum(ChebychevFlag(2:end,:)==2,1));


disp('draws with satisfied sufficient condition or fmincon solution (mean )');
disp(mean(ChebychevFlag(2:end,:)==1 | ChebychevFlag(2:end,:)==3,1));
disp('draws with satisfied sufficient condition or fmincon solution (std)');
disp(std(ChebychevFlag(2:end,:)==1 | ChebychevFlag(2:end,:)==3,1));
disp(std(ChebychevFlag(2:end,:)==1 | ChebychevFlag(2:end,:)==3,1)/sqrt(ndraws));

