%% I. Set color details
% -------------------------------------------------------------------------
DO_SAVE  = 1;
FontSize = 12;

GridRGB = [0 0 0]+.3;

RGB     = [.7 .7 .7]+.2;        RGB_E   = 'none';
SRRGB   = [255,160,122]/255;    SRRGB_E = 'none';
SR_RGB  = [139,  0,  0;
    220, 20, 60;
    240,128,128]/255;
HR_RGB  = [  0,  0,139;
    65,105,225;
    135,206,235]/255;
HRRGB   = [220, 20, 60]/255;    HRRGB_E = 'none';

IS_HRRGB   = [  0,191,255]/255;
IS_SRRGB   = [240,128,128]/255;

% here loop over whether the same draws are used for both SR and HR or not.
for USE_SAME_DRAWS = [true false]
    if ~USE_SAME_DRAWS
        SameSuffix    ='_nSM';
    else
        SameSuffix    ='';
    end;


%% Figure set 1: Density of Plug-in / Identified set
% =========================================================================
if ~ONLY_ALG2 % for Alg1 & Alg 2
    
    F_SR    = cell(nvar,1);
    XI_SR   = cell(nvar,1);
    F_HR    = cell(nvar,1);
    XI_HR   = cell(nvar,1);
    
%     SameIDX             =~squeeze(isnan(HRimpf_bound(1,1,1,:,1))) & ~any(squeeze(max(abs(reshape(HRimpf_bound, [nvar * nstep * nshocks, size(HRimpf_bound,4), 2])),[],1)>10),2) ;
    NumProblemIDX = abs(HRimpf_bound)>1e2 | abs(SRimpf_bound)>1e2;
    SRimpf_bound(NumProblemIDX) = NaN;
    HRimpf_bound(NumProblemIDX) = NaN;
    clear NumProblemIDX;
    SameIDX             = ~squeeze(isnan(HRimpf_bound(1,1,1,:,1))) & ~any(squeeze(max(abs(reshape(HRimpf_bound, [nvar * nstep * nshocks, size(HRimpf_bound,4), 2])),[],1)>10),2) ;
    if USE_SAME_DRAWS 
        SR_IDX              = SameIDX ;
    else
        SR_IDX              = ~squeeze(isnan(SRimpf_bound(1,1,1,:,1))) & ~any(squeeze(max(abs(reshape(SRimpf_bound, [nvar * nstep * nshocks, size(SRimpf_bound,4), 2])),[],1)>10),2) ;
    end;
    Robust_SRimpf_tmpGR = cell(nshocks,1);
    Robust_HRimpf_tmpGR = cell(nshocks,1);
    Robust_SRimpf_Extremes = cell(nshocks,1);
    Robust_HRimpf_Extremes = cell(nshocks,1);
    Bayes_SRimpf_tmpGR = cell(nshocks,1);
    Bayes_HRimpf_tmpGR = cell(nshocks,1);
    Bayes_SRimpf_tmpGR_alt = cell(nshocks,1);
    Bayes_HRimpf_tmpGR_alt = cell(nshocks,1);
    for ss=1:nshocks
        PC_GRID = [1 2.5 5 16 50 84 95 97.5 99];
        tmp_Bayes = squeeze(prctile( SIGN_IRFS_SR(:,:,ss,SameIDX,:), [5 95],5)); % for each reduced form draw, compute 5th and 95th percentiles
        Bayes_SRimpf_tmpGR_alt{ss} = nan(nvar, nstep, 2, length(PC_GRID));
        for gg=1:length(PC_GRID)
            Bayes_SRimpf_tmpGR_alt{ss}(:,:,:,gg) = squeeze(prctile( tmp_Bayes, PC_GRID(gg), 3)); 
        end;
        tmp_Bayes = squeeze(prctile( SIGN_IRFS_HR(:,:,ss,SameIDX,:), [5 95],5)); % for each reduced form draw, compute 5th and 95th prctiles
        Bayes_HRimpf_tmpGR_alt{ss} = nan(nvar, nstep, 2, length(PC_GRID));
        for gg=1:length(PC_GRID)
            Bayes_HRimpf_tmpGR_alt{ss}(:,:,:,gg) = squeeze(prctile( tmp_Bayes, PC_GRID(gg), 3)); 
        end;
        
        Bayes_SRimpf_tmpGR{ss} = squeeze(prctile(reshape(SIGN_IRFS_SR(:,:,ss,SameIDX,:), [nvar, nstep, sum(SameIDX)*ndraws_q]), [1 2.5 5 16 50 84 95 97.5 99],3));
        Bayes_HRimpf_tmpGR{ss} = squeeze(prctile(reshape(SIGN_IRFS_HR(:,:,ss,SameIDX,:), [nvar, nstep, sum(SameIDX)*ndraws_q]), [1 2.5 5 16 50 84 95 97.5 99],3));

        Robust_SRimpf_tmpGR{ss} = squeeze(prctile(SRimpf_bound(:,:,ss,SameIDX,:), [1 2.5 5 16 50 84 95 97.5 99],4));
        Robust_HRimpf_tmpGR{ss} = squeeze(prctile(HRimpf_bound(:,:,ss,SameIDX,:), [1 2.5 5 16 50 84 95 97.5 99],4));
        Robust_SRimpf_Extremes{ss} = squeeze(prctile(SRimpf_bound(:,:,ss,SameIDX,:), [0 100],4));
        Robust_HRimpf_Extremes{ss} = squeeze(prctile(HRimpf_bound(:,:,ss,SameIDX,:), [0 100],4));

        for nn = 1 : nvar
            [F_SR{nn}, XI_SR{nn}] = ksdensity( reshape(SIGN_IRFS_SR(nn,density_hh,ss,SameIDX,:), 1,[]), 'Function','pdf', 'Support', [min(squeeze(SRimpf_bound(nn,density_hh,ss,SameIDX,1))),max(squeeze(SRimpf_bound(nn,density_hh,ss,SameIDX,2)))]);
            [F_HR{nn}, XI_HR{nn}] = ksdensity( reshape(SIGN_IRFS_HR(nn,density_hh,ss,SameIDX,:), 1,[]), 'Function','pdf', 'Support', [min(squeeze(HRimpf_bound(nn,density_hh,ss,SameIDX,1))),max(squeeze(HRimpf_bound(nn,density_hh,ss,SameIDX,2)))]);

            figure; orient('Landscape'); hold all; grid on;

            leg_h(1) = plot(XI_SR{nn},F_SR{nn},'--', 'LineWidth', 3, 'Color', SR_RGB(2,:));
            leg_h(2) = plot(XI_HR{nn},F_HR{nn},'-', 'LineWidth', 3, 'Color', HR_RGB(2,:));

            %         leg_h(3) = plot([Robust_SRimpf_tmpGR(nn,hh,1,1) Robust_SRimpf_tmpGR(nn,hh,end,2)],[.98 .98]*max(ylim),'Color',SR_RGB(1,:),'linewidth',8);
            %         leg_h(4) = plot([Robust_HRimpf_tmpGR(nn,hh,1,1) Robust_HRimpf_tmpGR(nn,hh,end,2)],[.95 .95]*max(ylim),'Color',HR_RGB(1,:),'linewidth',8);
            leg_h(3) = plot([Robust_SRimpf_Extremes{ss}(nn,density_hh,1,1) Robust_SRimpf_Extremes{ss}(nn,density_hh,end,2)],-[.04 .04]*max(ylim),'Color',SR_RGB(1,:),'linewidth',8);
            leg_h(4) = plot([Robust_HRimpf_Extremes{ss}(nn,density_hh,1,1) Robust_HRimpf_Extremes{ss}(nn,density_hh,end,2)],-[.08 .08]*max(ylim),'Color',HR_RGB(1,:),'linewidth',8);

            title(varname{nn}); ylabel('density'); box('on')
            set(findall(gcf, '-property', 'FontSize'), 'FontSize', FontSize, 'fontWeight', 'normal','FontName','Times New Roman');
            set(findall(gcf,'type','axes'),'ycolor',GridRGB,'xcolor',GridRGB,'GridLineStyle','-','LineWidth',.5,'FontSize',FontSize);

    %         leg_ax=legend(leg_h,'SR_{FullyBayesian}','HR_{FullyBayesian}','SR_{PriorRobustBound}','HR_{PriorRobustBound}',...
    %             'Location','best','Orientation','vertical');
            % LEG = findobj(leg_ax,'type','text');
    %         set(leg_ax,'FontSize', FontSize+4, 'fontWeight', 'normal','FontName','Times New Roman')
    %         legend('boxoff');

            if DO_SAVE
                print(gcf, '-depsc', '-r300',sprintf(['%sNewStyleNumericalBoundsVariable_%d_Model%1.0f_H%d_s%d_dens' SameSuffix '.eps'],save_path_bound,nn, model_version,H,ss))
            end;
            % pause
    %         close all
        end;
    end;
else
    SameIDX=~squeeze(isnan(SIGN_IRFS_HR(1,1,1,:,1)));
    Bayes_SRimpf_tmpGR = cell(nshocks,1);
    Bayes_HRimpf_tmpGR = cell(nshocks,1);
    for ss=1:nshocks
        Bayes_SRimpf_tmpGR{ss} = squeeze(prctile(reshape(SIGN_IRFS_SR(:,:,ss,SameIDX,:), [nvar, nstep, sum(SameIDX)*ndraws_q]), [1 2.5 5 16 50 84 95 97.5 99],3));
        Bayes_HRimpf_tmpGR{ss} = squeeze(prctile(reshape(SIGN_IRFS_HR(:,:,ss,SameIDX,:), [nvar, nstep, sum(SameIDX)*ndraws_q]), [1 2.5 5 16 50 84 95 97.5 99],3));
    end;
end;

% %%
% if DO_MULTIPLIER
%     q_MULTIPLIER_HR= (1/defense_share) * (cumsum(squeeze(SIGN_IRFS_HR(sel_gdp_var,:,:,:)).*(discount_factor.^(0:nstep-1)'),1) ) ./(cumsum(squeeze(SIGN_IRFS_HR(sel_def_var,:,:,:)).*(discount_factor.^(0:nstep-1)') ,1)) ;
%     q_MULTIPLIER_SR= (1/defense_share) * (cumsum(squeeze(SIGN_IRFS_SR(sel_gdp_var,:,:,:)).*(discount_factor.^(0:nstep-1)'),1) ) ./(cumsum(squeeze(SIGN_IRFS_SR(sel_def_var,:,:,:)).*(discount_factor.^(0:nstep-1)') ,1)) ;
%     Bayes_SR_Multiplier = prctile(reshape(q_MULTIPLIER_SR(:,SameIDX,:), [nstep, sum(SameIDX)*ndraws_q]), [1 2.5 5 16 50 84 95 97.5 99],2);
%     Bayes_HR_Multiplier = prctile(reshape(q_MULTIPLIER_HR(:,SameIDX,:), [nstep, sum(SameIDX)*ndraws_q]), [1 2.5 5 16 50 84 95 97.5 99],2);
%     
% %     sel_hours_var=(strcmp('Hours', IncludeSeriesNames));
% %     q_LAB_PROD_HR= squeeze(SIGN_IRFS_HR(sel_gdp_var,:,:,:))-squeeze(SIGN_IRFS_HR(sel_hours_var,:,:,:));
% %     Bayes_HR_LAB_PROD= prctile(reshape(q_LAB_PROD_HR(:,SameIDX,:), [nstep, sum(SameIDX)*ndraws_q]), [1 2.5 5 16 50 84 95 97.5 99],2);
% 
% end;

%% Algorithm 1: Prior-robust posterior bounds
% =========================================================================
close all;

tmpa = [1:nstep nstep:-1:1]';

if ~ONLY_ALG2
    clear tmp_lim hub g h hlb tmpHR tmpSR tmp_lim
    for ss=1:nshocks
        for ii = 1 : nvar
            figure; orient('Landscape'); clear g h;

            gg(1) = subplot(1,2,1); hold('on');
            % Part 1: Outer Bounds
            tmpSR = [squeeze(Robust_SRimpf_tmpGR{ss}(ii,:,1+3,1))';flipdim(squeeze(Robust_SRimpf_tmpGR{ss}(ii,:,end-3,2))',1)];
            g(1) = patch(tmpa,tmpSR,RGB,'edgecolor',RGB_E,'HandleVisibility','on','LineWidth',2);

            % Part 2: Lower Bounds
            for jj = 1 : 3
                tmpSR = [squeeze(Robust_SRimpf_tmpGR{ss}(ii,:,1,1))';flipdim(squeeze(Robust_SRimpf_tmpGR{ss}(ii,:,5-jj,1))',1)];
                hlb(jj)=patch(tmpa,tmpSR,SR_RGB(jj,:),'edgecolor',RGB_E,'HandleVisibility','on','LineWidth',2);

            end

            % Part 3: Upper Bounds
            for jj = 1 : 3
                tmpSR = [squeeze(Robust_SRimpf_tmpGR{ss}(ii,:,end,2))';flipdim(squeeze(Robust_SRimpf_tmpGR{ss}(ii,:,end-4+jj,2))',1)];
                hub(jj)=patch(tmpa,tmpSR,SR_RGB(jj,:),'edgecolor',RGB_E,'HandleVisibility','on','LineWidth',2);
            end
            plot(1:nstep,zeros(1,nstep),'k','LineWidth',1);
            grid('on')
            title(sprintf('Sign Restrictions'),'FontSize',10,'FontName','Serif','FontWeight','Bold');
            % plot(1:25,squeeze((SRimpf_tmp1(ii,:,1:4,1))),'r',1:25,squeeze((SRimpf_tmp1(ii,:,6:end,2))),'b')
            xlabel(TimeLabel);ylabel(UnitLabel{ii});box('on');

            ylim_tmp = get(gca,'YLim');
            %--------------------------------------------------------------------------
            %--------------------------------------------------------------------------
            gg(2)=subplot(1,2,2);hold('on');
            % Part 1: Outer Bounds
            tmpHR = [squeeze(Robust_HRimpf_tmpGR{ss}(ii,:,1+3,1))';flipdim(squeeze(Robust_HRimpf_tmpGR{ss}(ii,:,end-3,2))',1)];
            g(2)=patch(tmpa,tmpHR,RGB,'edgecolor',RGB_E,  'HandleVisibility','on','LineWidth',2);
            % plot(1:nstep,zeros(1,nstep),'k','LineWidth',1);
            % Part 2: Lower Bounds
            for jj = 1 : 3
                tmpHR = [squeeze(Robust_HRimpf_tmpGR{ss}(ii,:,1,1))';flipdim(squeeze(Robust_HRimpf_tmpGR{ss}(ii,:,5-jj,1))',1)];
                hlb(jj)=patch(tmpa,tmpHR,HR_RGB(jj,:),'edgecolor',RGB_E,'HandleVisibility','on','LineWidth',2);

            end
            % Part 3: Upper Bounds
            for jj = 1 : 3
                tmpHR = [squeeze(Robust_HRimpf_tmpGR{ss}(ii,:,end,2))';flipdim(squeeze(Robust_HRimpf_tmpGR{ss}(ii,:,end-4+jj,2))',1)];
                hup(jj)=patch(tmpa,tmpHR,HR_RGB(jj,:),'edgecolor',RGB_E,'HandleVisibility','on','LineWidth',2);

            end
            plot(1:nstep,zeros(1,nstep),'k','LineWidth',1); grid('on')
            title(sprintf('Heterogeneity Restrictions'),'FontSize',10,'FontName','Serif','FontWeight','Bold');
            ylim_tmp = [ylim_tmp get(gca,'YLim')];
            tmp_lim = [min(ylim_tmp(:)) max(ylim_tmp(:))];
    %         set(gg,'XLim',[1 Plot_Horizon+1],'XTick',[1 7:6:Plot_Horizon-1],'XTickLabel',cellstr(num2str((0:3:Plot_Horizon)')),'YLim',[tmp_lim(1) tmp_lim(2)],'FontSize',8)
            set(gg,'XLim',[1 Plot_Horizon+1],'XTick',[0 MyXticks],'XTickLabel',cellstr(num2str(([1 MyXticks]-1)')),'YLim',[tmp_lim(1) tmp_lim(2)],'FontSize',8);
            set(gg(2), 'YAxisLocation', 'right')
            xlabel(TimeLabel);box('on');
            set(findall(gcf, '-property', 'FontSize'), 'FontSize', FontSize, 'fontWeight', 'normal','FontName','Times New Roman')
            set(findall(gcf,'type','axes'),'ycolor',GridRGB,'xcolor',GridRGB,'GridLineStyle','-','LineWidth',.5,'FontSize',FontSize)
            set(gg, 'YMinorGrid', 'on')        

            %--------------------------------------------------------------------------
            % Comparison with posterior mean
            %--------------------------------------------------------------------------
            subplot(1,2,1); 
            plot(1:nstep, squeeze( Mean_SRimpf_bound(ii,:,ss,:) ), '--k', 'LineWidth', 2);
            subplot(1,2,2); 
            plot(1:nstep, squeeze( Mean_HRimpf_bound(ii,:,ss,:) ), '--k', 'LineWidth', 2);
            %--------------------------------------------------------------------------
            %--------------------------------------------------------------------------

            if DO_SAVE
                if max(Do_Cumulative(:))==1
                    print(gcf, '-depsc', '-r300',sprintf(['%sNewStyleNumericalBoundsVariable_%d_Model%1.0f_H%d_s%d_lvl' SameSuffix '.eps'],save_path_bound,ii, model_version,H,ss))
                else
                    print(gcf, '-depsc', '-r300',sprintf(['%sNewStyleNumericalBoundsVariable_%d_Model%1.0f_H%d_s%d_TD' SameSuffix '.eps'],save_path_bound,ii, model_version,H,ss))
                end;
                %         print(gcf, '-dpdf', '-r300',sprintf('%sNumericalBoundsVariable_%d_TD.pdf',save_path_bound,ii))
            end


            % close all;
            clear tmp_lim hub g h hlb tmpHR tmpSR tmp_lim

        end

        SetReductionPercent=-100*([Robust_HRimpf_tmpGR{ss}(negSR_index<=NoMacroVars,:,[1],1); Robust_HRimpf_tmpGR{ss}(posSR_index<=NoMacroVars,:,[9],2)] ...
            ./[Robust_SRimpf_tmpGR{ss}(negSR_index<=NoMacroVars,:,[1],1); Robust_SRimpf_tmpGR{ss}(posSR_index<=NoMacroVars,:,[9],2)]-1);
%         if ss==1
        SetReductionVarnames=[varname(posSR_index<=NoMacroVars); varname(negSR_index<=NoMacroVars)];
%         end;

        TableSetReduction=[char(regexprep(SetReductionVarnames', '_', ' ')) num2str(SetReductionPercent, '& %1.1f') repmat('\\ ', NoMacroVars,1)];
        if DO_SAVE
            PreFixName = sprintf('%sNumericalBoundsVariable_Model%1.0f_H%d_s%d',save_path_bound, model_version,H,ss);

            my_fid = fopen( [PreFixName '_HR_B_IRF_Reduction' SameSuffix '.tex'], 'w');
            WriteTable=cellstr(TableSetReduction);
            fprintf(my_fid, '%s \n', WriteTable{:});
            fclose(my_fid);
        end;

        SetReductionPercent=-100*([Robust_HRimpf_tmpGR{ss}(negSR_index>NoMacroVars,:,[1],1); Robust_HRimpf_tmpGR{ss}(posSR_index>NoMacroVars,:,[9],2)] ...
            ./[Robust_SRimpf_tmpGR{ss}(negSR_index>NoMacroVars,:,[1],1); Robust_SRimpf_tmpGR{ss}(posSR_index>NoMacroVars,:,[9],2)]-1);
        SetReductionVarnames=[varname(posSR_index>NoMacroVars); varname(negSR_index>NoMacroVars)];

        TableSetReduction=[char(regexprep(SetReductionVarnames', '_', ' ')) num2str(SetReductionPercent, '& %1.1f') repmat('\\ ', nvar-NoMacroVars,1)];
        if DO_SAVE
            PreFixName = sprintf('%sNumericalBoundsVariable_Model%1.0f_H%d_s%d',save_path_bound, model_version,H,ss);

            my_fid = fopen( [PreFixName '_HR_B_IRF_Reduction_Micro' SameSuffix '.tex'], 'w');
            WriteTable=cellstr(TableSetReduction);
            fprintf(my_fid, '%s \n', WriteTable{:});
            fclose(my_fid);
        end;
    end;

end;

% error('keks')
%% Algorithm 2: Fully Bayesian posterior bounds
% =========================================================================
% Plot_Horizon=24;
close all;
tmpa = [1:nstep nstep:-1:1]';

if ~ONLY_ALG2
    clear tmp_lim hub g h hlb tmpHR tmpSR tmp_lim
    for ss=1:nshocks
        for ii = 1 : nvar
            figure; orient('Landscape'); clear g h;
             MinMaxSR = [squeeze(Robust_SRimpf_tmpGR{ss}(ii,:,1,1))',squeeze(Robust_SRimpf_tmpGR{ss}(ii,:,end,2))'];
             MinMaxHR = [squeeze(Robust_HRimpf_tmpGR{ss}(ii,:,1,1))',squeeze(Robust_HRimpf_tmpGR{ss}(ii,:,end,2))'];

            gg(1) = subplot(1,2,1); hold('on');

            % Part 2: Lower Bounds
            for jj = 1 : 3
                tmpSR = [squeeze(Bayes_SRimpf_tmpGR{ss}(ii,:,jj))';flipdim(squeeze(Bayes_SRimpf_tmpGR{ss}(ii,:,end-jj+1))',1)];
                hlb(1,jj)=patch(tmpa,tmpSR,SR_RGB(4-jj,:),'edgecolor',RGB_E,'HandleVisibility','on','LineWidth',2);

            end
            % Part 1: Outer Bounds
            tmpSR = [squeeze(Bayes_SRimpf_tmpGR{ss}(ii,:,4))';flipdim(squeeze(Bayes_SRimpf_tmpGR{ss}(ii,:,end-3))',1)];
            g(1) = patch(tmpa,tmpSR,RGB,'edgecolor',RGB_E,'HandleVisibility','on','LineWidth',2);
    %         Alg1_bounds_SR=plot(1:nstep, MinMaxSR, '--', 'Color', SR_RGB(1,:), 'LineWidth', 3);       

    %         % Part 3: Upper Bounds
    %         for jj = 2 : 4
    %             tmpSR = [squeeze(Bayes_SRimpf_tmpGR(ii,:,jj))';flipdim(squeeze(Bayes_SRimpf_tmpGR(ii,:,end-jj+1))',1)];
    %             hub(jj)=patch(tmpa,tmpSR,SR_RGB(jj,:),'edgecolor',RGB_E,'HandleVisibility','on','LineWidth',2);
    %         end
            plot(1:nstep,zeros(1,nstep),'k','LineWidth',1);
            grid('on')
            title(sprintf('Sign Restrictions'),'FontSize',10,'FontName','Serif','FontWeight','Bold');
            % plot(1:25,squeeze((SRimpf_tmp1(ii,:,1:4,1))),'r',1:25,squeeze((SRimpf_tmp1(ii,:,6:end,2))),'b')
            xlabel(TimeLabel);ylabel(UnitLabel{ii});box('on');

            ylim_tmp = get(gca,'YLim');
            %--------------------------------------------------------------------------
            %--------------------------------------------------------------------------
            gg(2)=subplot(1,2,2);hold('on');
            % Part 1: Outer Bounds

            % plot(1:nstep,zeros(1,nstep),'k','LineWidth',1);
            % Part 2: Lower Bounds
            for jj = 1:3
                tmpHR = [squeeze(Bayes_HRimpf_tmpGR{ss}(ii,:,jj))';flipdim(squeeze(Bayes_HRimpf_tmpGR{ss}(ii,:,end-jj+1))',1)];
                hlb(2,jj)=patch(tmpa,tmpHR,HR_RGB(4-jj,:),'edgecolor',RGB_E,'HandleVisibility','on','LineWidth',2);

            end
            tmpHR = [squeeze(Bayes_HRimpf_tmpGR{ss}(ii,:,4))';flipdim(squeeze(Bayes_HRimpf_tmpGR{ss}(ii,:,end-3))',1)];
            g(2)=patch(tmpa,tmpHR,RGB,'edgecolor',RGB_E,  'HandleVisibility','on','LineWidth',2);
    %         % Part 3: Upper Bounds
    %         for jj = 2 : 4
    %             tmpHR = [squeeze(Bayes_HRimpf_tmpGR(ii,:,jj))';flipdim(squeeze(Bayes_HRimpf_tmpGR(ii,:,end-jj+1))',1)];
    %             hup(jj)=patch(tmpa,tmpHR,HR_RGB(jj,:),'edgecolor',RGB_E,'HandleVisibility','on','LineWidth',2);
    %             
    %         end
            plot(1:nstep,zeros(1,nstep),'k','LineWidth',1); grid('on')
    %         Alg1_bounds_HR=plot(1:nstep, MinMaxHR, '--', 'Color', HR_RGB(1,:), 'LineWidth', 3);

            title(sprintf('Heterogeneity Restrictions'),'FontSize',10,'FontName','Serif','FontWeight','Bold');
            ylim_tmp = [ylim_tmp get(gca,'YLim')];
            tmp_lim = [min(ylim_tmp(:)) max(ylim_tmp(:))];
            set(gg,'XLim',[1 Plot_Horizon+1],'XTick',[0 MyXticks],'XTickLabel',cellstr(num2str(([1 MyXticks]-1)')),'YLim',[tmp_lim(1) tmp_lim(2)],'FontSize',8);
            set(gg(2), 'YAxisLocation', 'right')
            xlabel(TimeLabel);box('on');
            set(findall(gcf, '-property', 'FontSize'), 'FontSize', FontSize, 'fontWeight', 'normal','FontName','Times New Roman')
            set(findall(gcf,'type','axes'),'ycolor',GridRGB,'xcolor',GridRGB,'GridLineStyle','-','LineWidth',.5,'FontSize',FontSize)
    %         set(gg, 'YMinorGrid', 'on')        

            if DO_SAVE
                print(gcf, '-depsc', '-r300',sprintf(['%sNewStyleNumericalBoundsVariable_%d_Model%1.0f_H%d_s%d_Bayes' SameSuffix '.eps'],save_path_bound,ii, model_version,H,ss))
                %         print(gcf, '-dpdf', '-r300',sprintf('%sNumericalBoundsVariable_%d_TD.pdf',save_path_bound,ii))
            end

    %         delete(Alg1_bounds_HR);
    %         delete(Alg1_bounds_SR);
            delete(hlb(:,1))
            set(gg, 'YlimMode', 'Auto');
            ylim_tmp = [ylim_tmp get(gca,'YLim')];
            tmp_lim = [min(min(cell2mat(get(gg, 'Ylim')))) max(max(cell2mat(get(gg, 'Ylim'))))];
            set(gg,'XLim',[1 Plot_Horizon+1],'XTick',[0 MyXticks],'XTickLabel',cellstr(num2str(([1 MyXticks]-1)')),'YLim',[tmp_lim(1) tmp_lim(2)],'FontSize',8);
            set(findall(gcf, '-property', 'FontSize'), 'FontSize', FontSize, 'fontWeight', 'normal','FontName','Times New Roman')
            set(findall(gcf,'type','axes'),'ycolor',GridRGB,'xcolor',GridRGB,'GridLineStyle','-','LineWidth',.5,'FontSize',FontSize)

            if DO_SAVE
                print(gcf, '-depsc', '-r300',sprintf(['%sNewStyleNumericalBoundsVariable_%d_Model%1.0f_H%d_s%d_B_narrow' SameSuffix '.eps'],save_path_bound,ii, model_version,H,ss))
                %         print(gcf, '-dpdf', '-r300',sprintf('%sNumericalBoundsVariable_%d_TD.pdf',save_path_bound,ii))
            end

            % close all;
            clear tmp_lim hub g h hlb tmpHR tmpSR tmp_lim
            % close all;
            clear tmp_lim hub g h hlb tmpHR tmpSR tmp_lim

        end

        SetReductionPercent=-100*([Bayes_HRimpf_tmpGR{ss}(negSR_index<=NoMacroVars,:,[1]); Bayes_HRimpf_tmpGR{ss}(posSR_index<=NoMacroVars,:,[9])] ...
            ./[Bayes_SRimpf_tmpGR{ss}(negSR_index<=NoMacroVars,:,[1]); Bayes_SRimpf_tmpGR{ss}(posSR_index<=NoMacroVars,:,[9])]-1);
        SetReductionVarnames=[varname(posSR_index<=NoMacroVars); varname(negSR_index<=NoMacroVars)];

        TableSetReduction=[char(regexprep(SetReductionVarnames', '_', ' ')) num2str(SetReductionPercent, '& %1.1f') repmat('\\ ', NoMacroVars,1)];
        if DO_SAVE
            PreFixName = sprintf('%sNumericalBoundsVariable_Model%1.0f_H%d_s%d',save_path_bound, model_version,H,ss);

            my_fid = fopen( [PreFixName '_HR_B_IRF_Reduction_Bayes' SameSuffix '.tex'], 'w');
            WriteTable=cellstr(TableSetReduction);
            fprintf(my_fid, '%s \n', WriteTable{:});
            fclose(my_fid);
        end;

        SetReductionPercent=-100*([Bayes_HRimpf_tmpGR{ss}(negSR_index>NoMacroVars,:,[1]); Bayes_HRimpf_tmpGR{ss}(posSR_index>NoMacroVars,:,[9])] ...
            ./[Bayes_SRimpf_tmpGR{ss}(negSR_index>NoMacroVars,:,[1]); Bayes_SRimpf_tmpGR{ss}(posSR_index>NoMacroVars,:,[9])]-1);
        SetReductionVarnames=[varname(posSR_index>NoMacroVars); varname(negSR_index>NoMacroVars)];

        TableSetReduction=[char(regexprep(SetReductionVarnames', '_', ' ')) num2str(SetReductionPercent, '& %1.1f') repmat('\\ ', nvar-NoMacroVars,1)];
        if DO_SAVE
            PreFixName = sprintf('%sNumericalBoundsVariable_Model%1.0f_H%d_s%d',save_path_bound, model_version,H, ss);

            my_fid = fopen( [PreFixName '_HR_B_IRF_Reduction_Micro_Bayes' SameSuffix '.tex'], 'w');
            WriteTable=cellstr(TableSetReduction);
            fprintf(my_fid, '%s \n', WriteTable{:});
            fclose(my_fid);
        end;

    end;
end;

%% Algorithm 2: Fully Bayesian posterior bounds, but percentiles over percentiles
% =========================================================================
% Plot_Horizon=24;
close all;
tmpa = [1:nstep nstep:-1:1]';

if ~ONLY_ALG2
    clear tmp_lim hub g h hlb tmpHR tmpSR tmp_lim
    for ss=1:nshocks
        for ii = 1 : nvar
            figure; orient('Landscape'); clear g h;
  
            gg(1) = subplot(1,2,1); hold('on');

            % Part 2: Lower Bounds
            for jj = 1 : 3
                tmpSR = [squeeze(Bayes_SRimpf_tmpGR_alt{ss}(ii,:,1,jj))';flipdim(squeeze(Bayes_SRimpf_tmpGR_alt{ss}(ii,:,2,end-jj+1))',1)];
                hlb(1,jj)=patch(tmpa,tmpSR,SR_RGB(4-jj,:),'edgecolor',RGB_E,'HandleVisibility','on','LineWidth',2);

            end
            % Part 1: Outer Bounds
            tmpSR = [squeeze(Bayes_SRimpf_tmpGR_alt{ss}(ii,:,1,4))';flipdim(squeeze(Bayes_SRimpf_tmpGR_alt{ss}(ii,:,2,end-3))',1)];
            g(1) = patch(tmpa,tmpSR,RGB,'edgecolor',RGB_E,'HandleVisibility','on','LineWidth',2);
    %         Alg1_bounds_SR=plot(1:nstep, MinMaxSR, '--', 'Color', SR_RGB(1,:), 'LineWidth', 3);       

    %         % Part 3: Upper Bounds
    %         for jj = 2 : 4
    %             tmpSR = [squeeze(Bayes_SRimpf_tmpGR(ii,:,jj))';flipdim(squeeze(Bayes_SRimpf_tmpGR(ii,:,end-jj+1))',1)];
    %             hub(jj)=patch(tmpa,tmpSR,SR_RGB(jj,:),'edgecolor',RGB_E,'HandleVisibility','on','LineWidth',2);
    %         end
            plot(1:nstep,zeros(1,nstep),'k','LineWidth',1);
            grid('on')
            title(sprintf('Sign Restrictions'),'FontSize',10,'FontName','Serif','FontWeight','Bold');
            % plot(1:25,squeeze((SRimpf_tmp1(ii,:,1:4,1))),'r',1:25,squeeze((SRimpf_tmp1(ii,:,6:end,2))),'b')
            xlabel(TimeLabel);ylabel(UnitLabel{ii});box('on');

            ylim_tmp = get(gca,'YLim');
            %--------------------------------------------------------------------------
            %--------------------------------------------------------------------------
            gg(2)=subplot(1,2,2);hold('on');
            % Part 1: Outer Bounds

            % plot(1:nstep,zeros(1,nstep),'k','LineWidth',1);
            % Part 2: Lower Bounds
            for jj = 1:3
                tmpHR = [squeeze(Bayes_HRimpf_tmpGR_alt{ss}(ii,:,1,jj))';flipdim(squeeze(Bayes_HRimpf_tmpGR_alt{ss}(ii,:,2,end-jj+1))',1)];
                hlb(2,jj)=patch(tmpa,tmpHR,HR_RGB(4-jj,:),'edgecolor',RGB_E,'HandleVisibility','on','LineWidth',2);

            end
%             [squeeze(Bayes_HRimpf_tmpGR_alt{ss}(ii,:,1,4))',squeeze(Bayes_HRimpf_tmpGR_alt{ss}(ii,:,2,end-3))']
            tmpHR = [squeeze(Bayes_HRimpf_tmpGR_alt{ss}(ii,:,1,4))';flipdim(squeeze(Bayes_HRimpf_tmpGR_alt{ss}(ii,:,2,end-3))',1)];
            g(2)=patch(tmpa,tmpHR,RGB,'edgecolor',RGB_E,  'HandleVisibility','on','LineWidth',2);
    %         % Part 3: Upper Bounds
    %         for jj = 2 : 4
    %             tmpHR = [squeeze(Bayes_HRimpf_tmpGR(ii,:,jj))';flipdim(squeeze(Bayes_HRimpf_tmpGR(ii,:,end-jj+1))',1)];
    %             hup(jj)=patch(tmpa,tmpHR,HR_RGB(jj,:),'edgecolor',RGB_E,'HandleVisibility','on','LineWidth',2);
    %             
    %         end
            plot(1:nstep,zeros(1,nstep),'k','LineWidth',1); grid('on')
    %         Alg1_bounds_HR=plot(1:nstep, MinMaxHR, '--', 'Color', HR_RGB(1,:), 'LineWidth', 3);

            title(sprintf('Heterogeneity Restrictions'),'FontSize',10,'FontName','Serif','FontWeight','Bold');
            ylim_tmp = [ylim_tmp get(gca,'YLim')];
            tmp_lim = [min(ylim_tmp(:)) max(ylim_tmp(:))];
            set(gg,'XLim',[1 Plot_Horizon+1],'XTick',[0 MyXticks],'XTickLabel',cellstr(num2str(([1 MyXticks]-1)')),'YLim',[tmp_lim(1) tmp_lim(2)],'FontSize',8);
            set(gg(2), 'YAxisLocation', 'right')
            xlabel(TimeLabel);box('on');
            set(findall(gcf, '-property', 'FontSize'), 'FontSize', FontSize, 'fontWeight', 'normal','FontName','Times New Roman')
            set(findall(gcf,'type','axes'),'ycolor',GridRGB,'xcolor',GridRGB,'GridLineStyle','-','LineWidth',.5,'FontSize',FontSize)
    %         set(gg, 'YMinorGrid', 'on')        

            if DO_SAVE
                print(gcf, '-depsc', '-r300',sprintf(['%sNewStyleNumericalBoundsVariable_%d_Model%1.0f_H%d_s%d_Bayes_alt' SameSuffix '.eps'],save_path_bound,ii, model_version,H,ss))
                %         print(gcf, '-dpdf', '-r300',sprintf('%sNumericalBoundsVariable_%d_TD.pdf',save_path_bound,ii))
            end

    %         delete(Alg1_bounds_HR);
    %         delete(Alg1_bounds_SR);
            delete(hlb(:,1))
            set(gg, 'YlimMode', 'Auto');
            ylim_tmp = [ylim_tmp get(gca,'YLim')];
            tmp_lim = [min(min(cell2mat(get(gg, 'Ylim')))) max(max(cell2mat(get(gg, 'Ylim'))))];
            set(gg,'XLim',[1 Plot_Horizon+1],'XTick',[0 MyXticks],'XTickLabel',cellstr(num2str(([1 MyXticks]-1)')),'YLim',[tmp_lim(1) tmp_lim(2)],'FontSize',8);
            set(findall(gcf, '-property', 'FontSize'), 'FontSize', FontSize, 'fontWeight', 'normal','FontName','Times New Roman')
            set(findall(gcf,'type','axes'),'ycolor',GridRGB,'xcolor',GridRGB,'GridLineStyle','-','LineWidth',.5,'FontSize',FontSize)

            if DO_SAVE
                print(gcf, '-depsc', '-r300',sprintf(['%sNewStyleNumericalBoundsVariable_%d_Model%1.0f_H%d_s%d_B_nw_alt' SameSuffix '.eps'],save_path_bound,ii, model_version,H,ss))
                %         print(gcf, '-dpdf', '-r300',sprintf('%sNumericalBoundsVariable_%d_TD.pdf',save_path_bound,ii))
            end

            % close all;
            clear tmp_lim hub g h hlb tmpHR tmpSR tmp_lim
            % close all;
            clear tmp_lim hub g h hlb tmpHR tmpSR tmp_lim

        end

 

    end;
end;

 
%% Lagrange multipliers
close all
% error('work on LM');

if exist('LagrangeMultipliers','var')

    FormattedLabels = my_f_format_labels(RestrictionLabels, SlopeRestrictions, {'Employment','Emp.'; 'Confidence', 'Conf'; 'Consumers', 'Cons'});
    map_matrix = my_f_res_no_to_res_lbl( 1:res_total_count, H_bounds, H_bounds_slope );
    
    BoxPlotLabels=FormattedLabels;
    BoxPlotLabels=regexprep(BoxPlotLabels, '\$', '');

    BoxPlot_mshocks;
end;

end;

error('FEVD not implemented for multiple shocks ');
% 
% %% FEVD Analysis
% if DO_FEVD==2
%     FEVD_Analysis;
% end;