% Nitty gritty of code to produces plots and tables

%% Make allowance for structures

%% I. Set color details
% -------------------------------------------------------------------------
DO_SAVE  = 1;
FontSize = 12;

GridRGB = [0 0 0]+.3;

RGB     = [.7 .7 .7]+.2;        RGB_E   = 'none';
SRRGB   = [255,160,122]/255;    SRRGB_E = 'none';
SR_RGB  = [139,  0,  0;
    220, 20, 60;
    240,128,128]/255;
HR_RGB  = [  0,  0,139;
    65,105,225;
    135,206,235]/255;
HRRGB   = [220, 20, 60]/255;    HRRGB_E = 'none';

IS_HRRGB   = [  0,191,255]/255;
IS_SRRGB   = [240,128,128]/255;

% here loop over whether the same draws are used for both SR and HR or not.
for USE_SAME_DRAWS = [true false]
    if ~USE_SAME_DRAWS
        SameSuffix    ='_nSM';
    else
        SameSuffix    ='';
    end;
 

    %% Figure set 1: Density of Plug-in / Identified set
    % =========================================================================
    if ~ONLY_ALG2 % for Alg1 & Alg 2

        F_SR    = cell(nvar,1);
        XI_SR   = cell(nvar,1);
        F_HR    = cell(nvar,1);
        XI_HR   = cell(nvar,1);

        NumProblemIDX = abs(ResultsWoLM.HRimpf_bound)>1e2 | abs(ResultsWoLM.SRimpf_bound)>1e2;
        if sum(NumProblemIDX)>0
            ResultsWoLM.SRimpf_bound(find(NumProblemIDX)) = NaN;
            ResultsWoLM.HRimpf_bound(find(NumProblemIDX)) = NaN;
        end;
        clear NumProblemIDX;
        SameIDX             = ~squeeze(isnan(ResultsWoLM.HRimpf_bound(1,1,1,:,1))) & ~any(squeeze(max(abs(reshape(ResultsWoLM.HRimpf_bound, [nvar * nstep * nshocks, size(ResultsWoLM.HRimpf_bound,4), 2])),[],1)>10),2) ;
        if USE_SAME_DRAWS 
            SR_IDX              = SameIDX ;
        else
            SR_IDX              = ~squeeze(isnan(ResultsWoLM.SRimpf_bound(1,1,1,:,1))) & ~any(squeeze(max(abs(reshape(ResultsWoLM.SRimpf_bound, [nvar * nstep * nshocks, size(ResultsWoLM.SRimpf_bound,4), 2])),[],1)>10),2) ;
        end;
        Robust_SRimpf_tmpGR = cell(nshocks,1);
        Robust_HRimpf_tmpGR = cell(nshocks,1);
        Robust_SRimpf_Extremes = cell(nshocks,1);
        Robust_HRimpf_Extremes = cell(nshocks,1);
        Bayes_SRimpf_tmpGR = cell(nshocks,1);
        Bayes_HRimpf_tmpGR = cell(nshocks,1);
        Bayes_SRimpf_tmpGR_alt = cell(nshocks,1);
        Bayes_HRimpf_tmpGR_alt = cell(nshocks,1);

        for ss=1:nshocks
            PC_GRID = [1 2.5 5 16 50 84 95 97.5 99];
            Bayes_SRimpf_tmpGR{ss} = NaN(nvar, nstep, length(PC_GRID));
            Bayes_HRimpf_tmpGR{ss} = NaN(nvar, nstep, length(PC_GRID));
            Robust_SRimpf_tmpGR{ss} = NaN(nvar, nstep, length(PC_GRID), 2); % here: percentiles draw by draw - hence the last "2"
            Robust_HRimpf_tmpGR{ss} = NaN(nvar, nstep, length(PC_GRID), 2); % here: percentiles draw by draw - hence the last "2"
            Robust_SRimpf_Extremes{ss} = NaN(nvar, nstep, 2, 2); % here: percentiles draw by draw - hence the last "2"
            Robust_HRimpf_Extremes{ss} = NaN(nvar, nstep, 2, 2); % here: percentiles draw by draw - hence the last "2"
            
            for nn = 1 : nvar
                disp(num2str([nn, ss], 'Prior robust: variable %1.0f :: shock %1.0f'));
                % Prior robust - SR
                tic;
                tmp_extract = squeeze(ResultsWoLM.SRimpf_bound(nn,:,ss,:,:));
                toc;
                Robust_SRimpf_tmpGR{ss}(nn, :, :, :) = squeeze(prctile(tmp_extract(:,SR_IDX,:), [1 2.5 5 16 50 84 95 97.5 99],2));
                Robust_SRimpf_Extremes{ss}(nn, :, :, :) = squeeze(prctile(tmp_extract(:,SR_IDX,:), [0 100],2));
                % Prior robust - HR
                tmp_extract = squeeze(ResultsWoLM.HRimpf_bound(nn,:,ss,:,:));
                Robust_HRimpf_tmpGR{ss}(nn, :, :, :) = squeeze(prctile(tmp_extract(:,SameIDX,:), [1 2.5 5 16 50 84 95 97.5 99],2));
                Robust_HRimpf_Extremes{ss}(nn, :, :, :) = squeeze(prctile(tmp_extract(:,SameIDX,:), [0 100],2));

                disp(num2str([nn, ss], 'Fully bayesian: variable %1.0f :: shock %1.0f'));
                % Fully Bayesian - SR
                tic;
                tmp_extract = squeeze(ResultsWoLM.SIGN_IRFS_SR(nn,:,ss,:,:));
                toc;
                Bayes_SRimpf_tmpGR{ss}(nn, :, :) = squeeze(prctile(reshape(tmp_extract(:, SR_IDX, :), [nstep, sum(SR_IDX)*ndraws_q]), [1 2.5 5 16 50 84 95 97.5 99],2));
                [F_SR{nn}, XI_SR{nn}] = ksdensity( reshape(tmp_extract(density_hh, SR_IDX, :), 1,[]), 'Function','pdf', 'Support', ...
                    [Robust_SRimpf_Extremes{ss}(nn, density_hh, 1, 1), Robust_SRimpf_Extremes{ss}(nn, density_hh, 2, 2)]);
                % Fully Bayesian - HR
                tmp_extract = squeeze(ResultsWoLM.SIGN_IRFS_HR(nn,:,ss,:,:));
                Bayes_HRimpf_tmpGR{ss}(nn, :, :) = squeeze(prctile(reshape(tmp_extract(:, SameIDX, :), [nstep, sum(SameIDX)*ndraws_q]), [1 2.5 5 16 50 84 95 97.5 99],2));
                [F_HR{nn}, XI_HR{nn}] = ksdensity( reshape(tmp_extract(density_hh, SameIDX, :), 1,[]), 'Function','pdf', 'Support', ...
                    [Robust_HRimpf_Extremes{ss}(nn, density_hh, 1, 1), Robust_HRimpf_Extremes{ss}(nn, density_hh, 2, 2)]);

                figure; orient('Landscape'); hold all; grid on;

                leg_h(1) = plot(XI_SR{nn},F_SR{nn},'--', 'LineWidth', 3, 'Color', SR_RGB(2,:));
                leg_h(2) = plot(XI_HR{nn},F_HR{nn},'-', 'LineWidth', 3, 'Color', HR_RGB(2,:));

                leg_h(3) = plot([Robust_SRimpf_Extremes{ss}(nn,density_hh,1,1) Robust_SRimpf_Extremes{ss}(nn,density_hh,end,2)],-[.04 .04]*max(ylim),'Color',SR_RGB(1,:),'linewidth',8);
                leg_h(4) = plot([Robust_HRimpf_Extremes{ss}(nn,density_hh,1,1) Robust_HRimpf_Extremes{ss}(nn,density_hh,end,2)],-[.08 .08]*max(ylim),'Color',HR_RGB(1,:),'linewidth',8);

                title(varname{nn}); ylabel('density'); box('on')
                set(findall(gcf, '-property', 'FontSize'), 'FontSize', FontSize, 'fontWeight', 'normal','FontName','Times New Roman');
                set(findall(gcf,'type','axes'),'ycolor',GridRGB,'xcolor',GridRGB,'GridLineStyle','-','LineWidth',.5,'FontSize',FontSize);

                if DO_SAVE
                    print(gcf, '-depsc', '-r300',sprintf(['%sNewStyleNumericalBoundsVariable_%d_Model%1.0f_H%d_s%d_dens' SameSuffix '.eps'],save_path_bound,nn, model_version,H,ss))
                end
            end
        end
    else
        error('plotting with Alg 2 only is not maintained');
    end


    %% Algorithm 1: Prior-robust posterior bounds
    % =========================================================================
    close all;

    tmpa = [1:nstep nstep:-1:1]';

    if ~ONLY_ALG2
        clear tmp_lim hub g h hlb tmpHR tmpSR tmp_lim
        for ss=1:nshocks
            for ii = 1 : nvar
                figure; orient('Landscape'); clear g h;

                gg(1) = subplot(1,2,1); hold('on');
                % Part 1: Outer Bounds
                tmpSR = [squeeze(Robust_SRimpf_tmpGR{ss}(ii,:,1+3,1))';flipdim(squeeze(Robust_SRimpf_tmpGR{ss}(ii,:,end-3,2))',1)];
                g(1) = patch(tmpa,tmpSR,RGB,'edgecolor',RGB_E,'HandleVisibility','on','LineWidth',2);

                % Part 2: Lower Bounds
                for jj = 1 : 3
                    tmpSR = [squeeze(Robust_SRimpf_tmpGR{ss}(ii,:,1,1))';flipdim(squeeze(Robust_SRimpf_tmpGR{ss}(ii,:,5-jj,1))',1)];
                    hlb(jj)=patch(tmpa,tmpSR,SR_RGB(jj,:),'edgecolor',RGB_E,'HandleVisibility','on','LineWidth',2);

                end

                % Part 3: Upper Bounds
                for jj = 1 : 3
                    tmpSR = [squeeze(Robust_SRimpf_tmpGR{ss}(ii,:,end,2))';flipdim(squeeze(Robust_SRimpf_tmpGR{ss}(ii,:,end-4+jj,2))',1)];
                    hub(jj)=patch(tmpa,tmpSR,SR_RGB(jj,:),'edgecolor',RGB_E,'HandleVisibility','on','LineWidth',2);
                end
                plot(1:nstep,zeros(1,nstep),'k','LineWidth',1);
                grid('on')
                title(sprintf('Sign Restrictions'),'FontSize',10,'FontName','Serif','FontWeight','Bold');
                xlabel(TimeLabel);ylabel(UnitLabel{ii});box('on');

                ylim_tmp = get(gca,'YLim');
                %--------------------------------------------------------------------------
                %--------------------------------------------------------------------------
                gg(2)=subplot(1,2,2);hold('on');
                % Part 1: Outer Bounds
                tmpHR = [squeeze(Robust_HRimpf_tmpGR{ss}(ii,:,1+3,1))';flipdim(squeeze(Robust_HRimpf_tmpGR{ss}(ii,:,end-3,2))',1)];
                g(2)=patch(tmpa,tmpHR,RGB,'edgecolor',RGB_E,  'HandleVisibility','on','LineWidth',2);
                % Part 2: Lower Bounds
                for jj = 1 : 3
                    tmpHR = [squeeze(Robust_HRimpf_tmpGR{ss}(ii,:,1,1))';flipdim(squeeze(Robust_HRimpf_tmpGR{ss}(ii,:,5-jj,1))',1)];
                    hlb(jj)=patch(tmpa,tmpHR,HR_RGB(jj,:),'edgecolor',RGB_E,'HandleVisibility','on','LineWidth',2);

                end
                % Part 3: Upper Bounds
                for jj = 1 : 3
                    tmpHR = [squeeze(Robust_HRimpf_tmpGR{ss}(ii,:,end,2))';flipdim(squeeze(Robust_HRimpf_tmpGR{ss}(ii,:,end-4+jj,2))',1)];
                    hup(jj)=patch(tmpa,tmpHR,HR_RGB(jj,:),'edgecolor',RGB_E,'HandleVisibility','on','LineWidth',2);

                end
                plot(1:nstep,zeros(1,nstep),'k','LineWidth',1); grid('on')
                title(sprintf('Heterogeneity Restrictions'),'FontSize',10,'FontName','Serif','FontWeight','Bold');
                ylim_tmp = [ylim_tmp get(gca,'YLim')];
                tmp_lim = [min(ylim_tmp(:)) max(ylim_tmp(:))];
                set(gg,'XLim',[1 Plot_Horizon+1],'XTick',[0 MyXticks],'XTickLabel',cellstr(num2str(([1 MyXticks]-1)')),'YLim',[tmp_lim(1) tmp_lim(2)],'FontSize',8);
                set(gg(2), 'YAxisLocation', 'right')
                xlabel(TimeLabel);box('on');
                set(findall(gcf, '-property', 'FontSize'), 'FontSize', FontSize, 'fontWeight', 'normal','FontName','Times New Roman')
                set(findall(gcf,'type','axes'),'ycolor',GridRGB,'xcolor',GridRGB,'GridLineStyle','-','LineWidth',.5,'FontSize',FontSize)
                set(gg, 'YMinorGrid', 'on')        

                %--------------------------------------------------------------------------
                % Comparison with posterior mean
                %--------------------------------------------------------------------------
                subplot(1,2,1); 
                plot(1:nstep, squeeze( Mean_SRimpf_bound(ii,:,ss,:) ), '--k', 'LineWidth', 2);
                subplot(1,2,2); 
                plot(1:nstep, squeeze( Mean_HRimpf_bound(ii,:,ss,:) ), '--k', 'LineWidth', 2);
                %--------------------------------------------------------------------------
                %--------------------------------------------------------------------------

                if DO_SAVE
                    if max(Do_Cumulative(:))==1
                        print(gcf, '-depsc', '-r300',sprintf(['%sNewStyleNumericalBoundsVariable_%d_Model%1.0f_H%d_s%d_lvl' SameSuffix '.eps'],save_path_bound,ii, model_version,H,ss))
                    else
                        print(gcf, '-depsc', '-r300',sprintf(['%sNewStyleNumericalBoundsVariable_%d_Model%1.0f_H%d_s%d_TD' SameSuffix '.eps'],save_path_bound,ii, model_version,H,ss))
                    end
                end
                
                clear tmp_lim hub g h hlb tmpHR tmpSR tmp_lim

            end

            SetReductionPercent=-100*([Robust_HRimpf_tmpGR{ss}(negSR_index<=NoMacroVars,:,[1],1); Robust_HRimpf_tmpGR{ss}(posSR_index<=NoMacroVars,:,[9],2)] ...
                ./[Robust_SRimpf_tmpGR{ss}(negSR_index<=NoMacroVars,:,[1],1); Robust_SRimpf_tmpGR{ss}(posSR_index<=NoMacroVars,:,[9],2)]-1);
            SetReductionVarnames=[varname(posSR_index<=NoMacroVars); varname(negSR_index<=NoMacroVars)];

            TableSetReduction=[char(regexprep(SetReductionVarnames', '_', ' ')) num2str(SetReductionPercent, '& %1.1f') repmat('\\ ', NoMacroVars,1)];
            if DO_SAVE
                PreFixName = sprintf('%sNumericalBoundsVariable_Model%1.0f_H%d_s%d',save_path_bound, model_version,H,ss);

                my_fid = fopen( [PreFixName '_HR_B_IRF_Reduction' SameSuffix '.tex'], 'w');
                WriteTable=cellstr(TableSetReduction);
                fprintf(my_fid, '%s \n', WriteTable{:});
                fclose(my_fid);
            end

            SetReductionPercent=-100*([Robust_HRimpf_tmpGR{ss}(negSR_index>NoMacroVars,:,[1],1); Robust_HRimpf_tmpGR{ss}(posSR_index>NoMacroVars,:,[9],2)] ...
                ./[Robust_SRimpf_tmpGR{ss}(negSR_index>NoMacroVars,:,[1],1); Robust_SRimpf_tmpGR{ss}(posSR_index>NoMacroVars,:,[9],2)]-1);
            SetReductionVarnames=[varname(posSR_index>NoMacroVars); varname(negSR_index>NoMacroVars)];

            TableSetReduction=[char(regexprep(SetReductionVarnames', '_', ' ')) num2str(SetReductionPercent, '& %1.1f') repmat('\\ ', nvar-NoMacroVars,1)];
            if DO_SAVE
                PreFixName = sprintf('%sNumericalBoundsVariable_Model%1.0f_H%d_s%d',save_path_bound, model_version,H,ss);

                my_fid = fopen( [PreFixName '_HR_B_IRF_Reduction_Micro' SameSuffix '.tex'], 'w');
                WriteTable=cellstr(TableSetReduction);
                fprintf(my_fid, '%s \n', WriteTable{:});
                fclose(my_fid);
            end
        end

    end

    %% Algorithm 2: Fully Bayesian posterior bounds
    % =========================================================================

    close all;
    tmpa = [1:nstep nstep:-1:1]';

    if ~ONLY_ALG2
        clear tmp_lim hub g h hlb tmpHR tmpSR tmp_lim
        for ss=1:nshocks
            for ii = 1 : nvar
                figure; orient('Landscape'); clear g h;
                 MinMaxSR = [squeeze(Robust_SRimpf_tmpGR{ss}(ii,:,1,1))',squeeze(Robust_SRimpf_tmpGR{ss}(ii,:,end,2))'];
                 MinMaxHR = [squeeze(Robust_HRimpf_tmpGR{ss}(ii,:,1,1))',squeeze(Robust_HRimpf_tmpGR{ss}(ii,:,end,2))'];

                gg(1) = subplot(1,2,1); hold('on');

                % Part 2: Lower Bounds
                for jj = 1 : 3
                    tmpSR = [squeeze(Bayes_SRimpf_tmpGR{ss}(ii,:,jj))';flipdim(squeeze(Bayes_SRimpf_tmpGR{ss}(ii,:,end-jj+1))',1)];
                    hlb(1,jj)=patch(tmpa,tmpSR,SR_RGB(4-jj,:),'edgecolor',RGB_E,'HandleVisibility','on','LineWidth',2);

                end
                % Part 1: Outer Bounds
                tmpSR = [squeeze(Bayes_SRimpf_tmpGR{ss}(ii,:,4))';flipdim(squeeze(Bayes_SRimpf_tmpGR{ss}(ii,:,end-3))',1)];
                g(1) = patch(tmpa,tmpSR,RGB,'edgecolor',RGB_E,'HandleVisibility','on','LineWidth',2);
                plot(1:nstep,zeros(1,nstep),'k','LineWidth',1);
                grid('on')
                title(sprintf('Sign Restrictions'),'FontSize',10,'FontName','Serif','FontWeight','Bold');
                xlabel(TimeLabel);ylabel(UnitLabel{ii});box('on');

                ylim_tmp = get(gca,'YLim');
                %--------------------------------------------------------------------------
                %--------------------------------------------------------------------------
                gg(2)=subplot(1,2,2);hold('on');
                % Part 2: Lower Bounds
                for jj = 1:3
                    tmpHR = [squeeze(Bayes_HRimpf_tmpGR{ss}(ii,:,jj))';flipdim(squeeze(Bayes_HRimpf_tmpGR{ss}(ii,:,end-jj+1))',1)];
                    hlb(2,jj)=patch(tmpa,tmpHR,HR_RGB(4-jj,:),'edgecolor',RGB_E,'HandleVisibility','on','LineWidth',2);

                end
                tmpHR = [squeeze(Bayes_HRimpf_tmpGR{ss}(ii,:,4))';flipdim(squeeze(Bayes_HRimpf_tmpGR{ss}(ii,:,end-3))',1)];
                g(2)=patch(tmpa,tmpHR,RGB,'edgecolor',RGB_E,  'HandleVisibility','on','LineWidth',2);
                % Part 3: Upper Bounds
                plot(1:nstep,zeros(1,nstep),'k','LineWidth',1); grid('on')

                title(sprintf('Heterogeneity Restrictions'),'FontSize',10,'FontName','Serif','FontWeight','Bold');
                ylim_tmp = [ylim_tmp get(gca,'YLim')];
                tmp_lim = [min(ylim_tmp(:)) max(ylim_tmp(:))];
                set(gg,'XLim',[1 Plot_Horizon+1],'XTick',[0 MyXticks],'XTickLabel',cellstr(num2str(([1 MyXticks]-1)')),'YLim',[tmp_lim(1) tmp_lim(2)],'FontSize',8);
                set(gg(2), 'YAxisLocation', 'right')
                xlabel(TimeLabel);box('on');
                set(findall(gcf, '-property', 'FontSize'), 'FontSize', FontSize, 'fontWeight', 'normal','FontName','Times New Roman')
                set(findall(gcf,'type','axes'),'ycolor',GridRGB,'xcolor',GridRGB,'GridLineStyle','-','LineWidth',.5,'FontSize',FontSize)

                if DO_SAVE
                    print(gcf, '-depsc', '-r300',sprintf(['%sNewStyleNumericalBoundsVariable_%d_Model%1.0f_H%d_s%d_Bayes' SameSuffix '.eps'],save_path_bound,ii, model_version,H,ss))
                end

                delete(hlb(:,1))
                set(gg, 'YlimMode', 'Auto');
                ylim_tmp = [ylim_tmp get(gca,'YLim')];
                tmp_lim = [min(min(cell2mat(get(gg, 'Ylim')))) max(max(cell2mat(get(gg, 'Ylim'))))];
                set(gg,'XLim',[1 Plot_Horizon+1],'XTick',[0 MyXticks],'XTickLabel',cellstr(num2str(([1 MyXticks]-1)')),'YLim',[tmp_lim(1) tmp_lim(2)],'FontSize',8);
                set(findall(gcf, '-property', 'FontSize'), 'FontSize', FontSize, 'fontWeight', 'normal','FontName','Times New Roman')
                set(findall(gcf,'type','axes'),'ycolor',GridRGB,'xcolor',GridRGB,'GridLineStyle','-','LineWidth',.5,'FontSize',FontSize)

                if DO_SAVE
                    print(gcf, '-depsc', '-r300',sprintf(['%sNewStyleNumericalBoundsVariable_%d_Model%1.0f_H%d_s%d_B_narrow' SameSuffix '.eps'],save_path_bound,ii, model_version,H,ss))
                end

                clear tmp_lim hub g h hlb tmpHR tmpSR tmp_lim

            end

            SetReductionPercent=-100*([Bayes_HRimpf_tmpGR{ss}(negSR_index<=NoMacroVars,:,[1]); Bayes_HRimpf_tmpGR{ss}(posSR_index<=NoMacroVars,:,[9])] ...
                ./[Bayes_SRimpf_tmpGR{ss}(negSR_index<=NoMacroVars,:,[1]); Bayes_SRimpf_tmpGR{ss}(posSR_index<=NoMacroVars,:,[9])]-1);
            SetReductionVarnames=[varname(posSR_index<=NoMacroVars); varname(negSR_index<=NoMacroVars)];

            TableSetReduction=[char(regexprep(SetReductionVarnames', '_', ' ')) num2str(SetReductionPercent, '& %1.1f') repmat('\\ ', NoMacroVars,1)];
            if DO_SAVE
                PreFixName = sprintf('%sNumericalBoundsVariable_Model%1.0f_H%d_s%d',save_path_bound, model_version,H,ss);

                my_fid = fopen( [PreFixName '_HR_B_IRF_Reduction_Bayes' SameSuffix '.tex'], 'w');
                WriteTable=cellstr(TableSetReduction);
                fprintf(my_fid, '%s \n', WriteTable{:});
                fclose(my_fid);
            end

            SetReductionPercent=-100*([Bayes_HRimpf_tmpGR{ss}(negSR_index>NoMacroVars,:,[1]); Bayes_HRimpf_tmpGR{ss}(posSR_index>NoMacroVars,:,[9])] ...
                ./[Bayes_SRimpf_tmpGR{ss}(negSR_index>NoMacroVars,:,[1]); Bayes_SRimpf_tmpGR{ss}(posSR_index>NoMacroVars,:,[9])]-1);
            SetReductionVarnames=[varname(posSR_index>NoMacroVars); varname(negSR_index>NoMacroVars)];

            TableSetReduction=[char(regexprep(SetReductionVarnames', '_', ' ')) num2str(SetReductionPercent, '& %1.1f') repmat('\\ ', nvar-NoMacroVars,1)];
            if DO_SAVE
                PreFixName = sprintf('%sNumericalBoundsVariable_Model%1.0f_H%d_s%d',save_path_bound, model_version,H, ss);

                my_fid = fopen( [PreFixName '_HR_B_IRF_Reduction_Micro_Bayes' SameSuffix '.tex'], 'w');
                WriteTable=cellstr(TableSetReduction);
                fprintf(my_fid, '%s \n', WriteTable{:});
                fclose(my_fid);
            end

        end
    end

    %% Lagrange multipliers
    close all
    if exist('LagrangeMultipliers','var')

        FormattedLabels = my_f_format_labels(RestrictionLabels, SlopeRestrictions, {'Employment','Emp.'; 'Confidence', 'Conf'; 'Consumers', 'Cons'});
        map_matrix = my_f_res_no_to_res_lbl( 1:res_total_count, H_bounds, H_bounds_slope );

        BoxPlotLabels=FormattedLabels;
        BoxPlotLabels=regexprep(BoxPlotLabels, '\$', '');

        BoxPlot_mshocks;
    end
end

fprintf(2,'FEVD plots not implemented for multiple shocks -- manual table');
