% Code to extent our baseline analysis of TFP news shocks to a second
% surprise TFP shock
% Currently works for case 11 only

%% Code to compare Sign Restriction to Heterogeneity Restriciton in a VAR
% -------------------------------------------------------------------------
clear('all'); close('all'); 
% clc;

% addpath('C:\Program Files\Artelys\Knitro 10.3.2\knitromatlab');
%rmpath('C:\Program Files\Artelys\Knitro 10.3.2\knitromatlab');
addpath('C:\Program Files\Artelys\Knitro 12.0.0\knitromatlab');
%rmpath('C:\Program Files\Artelys\Knitro 11.0.0\knitromatlab');

main_path = pwd;
% load_path = '../../Data/';
load_path = '';
% addpath('../HRSR2/')
cd(main_path)
PreFixName='News';
save_path_bound='Graphs/';

% Specifications:
% -------------------------------------------------------------------------
DO_SAVE = true;
DO_PLOT = 0;
DO_FEVD = 0; % >0: Do FEVD at posterior mean. =2: Also do for each draw

CHECK_ONLY = false ; % if true, only compute whether the identified sets are non-empty
PLUG_IN_ONLY = false ;

DO_SLOPE_W_SR = false;

START_1983 = false;

% "Tuning" parameters for Algorithm 1
DO_ALG2_START = true; % check if best draw yields a better outcome in fmincon
DO_CHEB_START = true; % check if Chebychev yields a better outcome in fmincon. If false, don't do warm starts using last horizon's q and use Chebychev there
DO_RAND_START =  true; % check if random perturbation yields a better outcome in fmincon
NO_RAND_STARTS = 5;
ndraws_q    = 5000;
ndraws      = 50;
nstep       = 25;               % number of steps for impulse responses
GibbsStep   = 10;

WhichSeed = 42; %Douglas Adams 
rng(WhichSeed);

% Split sample into parts? 
ParallelParts = 2;
WhichParallelPart = 2;
CurrentDraws = ceil(ndraws/ParallelParts);
%% PART ONE: LOADING DATA AND SPECIFICATIONS
% -------------------------------------------------------------------------

% do not use 20 as a model version, bc it is generated with TFP_lambda = 20
% and model_version = 0
HR_MULTIPLE = 1;
model_version   = 11;
% 7410;  % 0, 2: no micro data. 11, 21: used in paper. 31: Like 11, but no restriction on hours. %41 5 FF + C. % 51 10 FF + C % 91: Book to Market
% if ~isequal(model_version,11) && ~isequal(model_version,99) && ~isequal(model_version,999) && ~isequal(model_version,998) ...
%         && ~isequal(model_version, 77) && ~isequal(model_version, 779) && ~isequal(model_version, 778) ...
%         && ~isequal(model_version, 76)
%     error('currently implemented for versions 11 and 99 and 99x only!');
% end
% low book to market: growth stock, should read more. 91: Reverse: Value stocks load more on TFP
H           = 5 ; % Horzin for restrictions to hold
TFP_Lambda=0;
% TFP_Lambda=1; % Output rises more than it would just based on TFP --
% sensible economic restriction!
% TFP_Lambda=10; % used in paper
% TFP_Lambda=20; % used for future reference with model versions 0 and 2.

file_name   = 'Data/TFP_Stock_Data.csv'; 


%% 
my_model_setup;

%%


if TFP_Lambda~=0 
    if unique(HR_MULTIPLE)~=1 || length(RestrictionLabels)>1
        error('Soft zero on TFP currently not incorporated with these options');
    end
%     my_EnglishToMatrices_Slopes_cell
    SoftZero_Restriction=cell(1,1);
    SoftZero_Restriction{1}={'Output>TFP', 1,1,1};
%     [SS_TFP, EE_TFP, LL_TFP, Do_Cumulative_R_TFP]=my_EnglishToMatrices({'Output>TFP', 1},IncludeSeriesNames,[]);
    [SS_TFP , EE_TFP, LL_TFP, H_bounds_TFP, Do_Cumulative_R_TFP, ~, nres_TFP, ~, ~, ~, SS_combined_TFP, EE_combined_TFP, LL_combined_TFP] ...
            = my_EnglishToMatrices_cell(SoftZero_Restriction,IncludeSeriesNames,[]);

    LL_TFP{1} = LL_TFP{1}*TFP_Lambda;
    RestrictionLabels{1}=[RestrictionLabels{1};SoftZero_Restriction{1}];
    SS{1}=[SS{1}, zeros(size(SS{1},1),1); zeros(1, size(SS{1},1)), SS_TFP{1}];
    EE{1}=[EE{1}; EE_TFP{1}];
%     LL_past_impact=[LL; LL_TFP*0];
    LL{1}=[LL{1}; LL_TFP{1}];
    H_bounds{1} = [H_bounds{1}; H_bounds_TFP{1}];
    nres = nres + nres_TFP;
    LL_past_impact=LL;
    if DO_SLOPE_W_SR
        hh=1;
        SlopeRestrictions_tmp={'TFP', 1,1, hh, hh+1};
        for hh=2:H-1
            SlopeRestrictions_tmp = [ ...
                SlopeRestrictions_tmp; 
               {'TFP', 1,1, hh, hh+1}; ... initially increasing
                ];
        end
        SlopeRestrictions{1}=SlopeRestrictions_tmp;
        [SS_slope,EE_slope,H_bounds_slope, Do_Cumulative_R_slope, FAVAR_IDX_slope, nres_slope, ~, ~, ~, SS_combined_slope, EE_combined_slope] ...
            = my_EnglishToMatrices_Slopes_cell(SlopeRestrictions,IncludeSeriesNames,[]);        
    end
elseif DO_SLOPE_W_SR 
        hh=1;
        SlopeRestrictions_tmp={'TFP', 1,1, hh, hh+1};
        for hh=2:H-1
            SlopeRestrictions_tmp = [ ...
                SlopeRestrictions_tmp; 
               {'TFP', 1,1, hh, hh+1}; ... initially increasing
                ];
        end
        SlopeRestrictions{1}=SlopeRestrictions_tmp;
        [SS_slope,EE_slope,H_bounds_slope, Do_Cumulative_R_slope, FAVAR_IDX_slope, nres_slope, ~, ~, ~, SS_combined_slope, EE_combined_slope] ...
            = my_EnglishToMatrices_Slopes_cell(SlopeRestrictions,IncludeSeriesNames,[]);        
    LL_past_impact=LL;
else
    LL_past_impact=LL;
end

% Reduced form prior parameters
if model_version==7410 
    hyperparams.tau     =   1/4;             % 0.1 overall tightness */
    hyperparams.d       =   2.5;               % scaling down the variance for the coefficients of a distant lag */
    hyperparams.w       =   1;               % number of observations used for obtaining the prior for the covariance matrix of error terms*/
    hyperparams.lambda  =   1/4;               % 2.3 tuning parameter for coefficients for constant*/
    hyperparams.mu      =   1/4;               % 12 tuning parameter for the covariance between coefficients*/
    prior_only=0;
elseif model_version==7411 
    hyperparams.tau     =   .5;             % 0.1 overall tightness */
    hyperparams.d       =   2.5;               % scaling down the variance for the coefficients of a distant lag */
    hyperparams.w       =   1;               % number of observations used for obtaining the prior for the covariance matrix of error terms*/
    hyperparams.lambda  =   0.5;               % 2.3 tuning parameter for coefficients for constant*/
    hyperparams.mu      =   0.5;               % 12 tuning parameter for the covariance between coefficients*/
    prior_only=0;
elseif model_version==7412 
    hyperparams.tau     =   1;             % 0.1 overall tightness */
    hyperparams.d       =   2.5;               % scaling down the variance for the coefficients of a distant lag */
    hyperparams.w       =   1;               % number of observations used for obtaining the prior for the covariance matrix of error terms*/
    hyperparams.lambda  =   1;               % 2.3 tuning parameter for coefficients for constant*/
    hyperparams.mu      =   1;               % 12 tuning parameter for the covariance between coefficients*/
    prior_only=0;
elseif model_version==101
    hyperparams.tau     =   1;             % 0.1 overall tightness */
    hyperparams.d       =   2.5;               % scaling down the variance for the coefficients of a distant lag */
    hyperparams.w       =   1;               % number of observations used for obtaining the prior for the covariance matrix of error terms*/
    hyperparams.lambda  =   1;               % 2.3 tuning parameter for coefficients for constant*/
    hyperparams.mu      =   1;               % 12 tuning parameter for the covariance between coefficients*/
    prior_only=0;
elseif model_version==102
    hyperparams.tau     =   .5;             % 0.1 overall tightness */
    hyperparams.d       =   2.5;               % scaling down the variance for the coefficients of a distant lag */
    hyperparams.w       =   1;               % number of observations used for obtaining the prior for the covariance matrix of error terms*/
    hyperparams.lambda  =   0.5;               % 2.3 tuning parameter for coefficients for constant*/
    hyperparams.mu      =   0.5;               % 12 tuning parameter for the covariance between coefficients*/
    prior_only=0;
%     hyperparams.tau     =   0;             % 0.1 overall tightness */
%     hyperparams.d       =   0;               % scaling down the variance for the coefficients of a distant lag */
%     hyperparams.w       =   0;               % number of observations used for obtaining the prior for the covariance matrix of error terms*/
%     hyperparams.lambda  =   0;               % 2.3 tuning parameter for coefficients for constant*/
%     hyperparams.mu      =   0;               % 12 tuning parameter for the covariance between coefficients*/
else
    prior_only=-1;
    hyperparams.tau     =   0;             % 0.1 overall tightness */
    hyperparams.d       =   0;               % scaling down the variance for the coefficients of a distant lag */
    hyperparams.w       =   0;               % number of observations used for obtaining the prior for the covariance matrix of error terms*/
    hyperparams.lambda  =   0;               % 2.3 tuning parameter for coefficients for constant*/
    hyperparams.mu      =   0;               % 12 tuning parameter for the covariance between coefficients*/
end

time_all=numeric_data(:,strcmp('year', varnameAll));
% time_all    = 1972+(2/12):(1/12):2015+(12/12);
% beg_date = 1;
% end_date = length(time_all);
% beg_date = find(time_all==1980);
% end_date = find(time_all==2005);
% if model_version~=999
    beg_date    = find(time_all>1960,1);
% else
%     beg_date    = find(time_all>=1971,1);    
% end
 
if any(strcmp(varname, 'xxxFFR'))
    beg_date    = find(time_all>1984,1);
    end_date    = find(time_all==2007);
else
    end_date    = find(time_all==2015);
end
if START_1983
    beg_date    = find(time_all>=1983,1);
    end_date    = find(time_all==2016);
%     end_date    = find(time_all==2008)-1;
%     end_date    = find(time_all==1979)-1;
    model_version = str2double(['6' char(extractAfter(num2str(model_version),1))]);
end
if ~isequal(HR_MULTIPLE, 1)
     model_version = model_version*100+HR_MULTIPLE(end)*10;
end
time_ax     = time_all(beg_date:end_date);

% for nn = 1:length(data_index)
%     if Do_Cumulative(nn)
%         numeric_data(:,data_index(nn))=[NaN(1); diff(log(numeric_data(:,data_index(nn))))*100];
%     end
% end
ydata       = numeric_data(beg_date:end_date,data_index);
ydata(any(isnan(ydata),2),:)=[];
if model_version == 11
    Plot_Raw_Data;
end

[T,nvar]    = size(ydata); %nvar is the number of variables, T is the number of data points
if model_version>=10
    xdata       = [ones(T,1), (1:T)', ((1:T).^2)' ] ; %option to use if you want to use a constant only, no seasonal dummies
else
    xdata       = ones(T,1); %option to use if you want to use a constant only, no seasonal dummies
end

lags=4;

%% Graphics config
% use that they are conveniently ordered first
if ~any(cellfun(@isempty, strfind(IncludeSeriesNames,'Consumption')))
    NoMacroVars = 5;
else
    NoMacroVars = 4;
end
Grid = [1 9 25];
legendEntries = {'Impact'; '2 years out'; '6 years out'};
TimeLabel='Horizon (quarters)';
UnitLabel=cell(nvar,1);
UnitLabel(:)={'Percent'};
Plot_Horizon=24;
density_hh = 9;
MyXticks=5:4:Plot_Horizon+1;

%% PART TWO: MAKING POSTERIOR DRAWS
% -------------------------------------------------------------------------
% nalpha      = 1;

% ndraw_frac  = ndraws*nalpha*.25;
ndraw_frac  = ndraws;
nlag        = lags+1;
% sr_horz     = nstep;
% sr_horz     = 2;

% [By,Bx,omega]       = rfvardraws(ydata, lags,xdata,lambda,mu,ndraws);

Do_CumulativeMatrix=Do_Cumulative*ones(1,nvar); 

% [By,Bx,omega]       = rfvardraws_v3(ydata, lags,xdata,lambda,mu,ndraws,lambda3,false);
[By,Bx,omega]=rfvardraws_dummyobs(ydata,lags,xdata,ndraws,hyperparams, prior_only);

if CHECK_ONLY && hyperparams.w>0 && prior_only~=-1 % draw from prior
    [prior_By,prior_Bx,prior_omega]       =rfvardraws_dummyobs(ydata,lags,xdata,ndraws,hyperparams, true);
end

J           = [eye(nvar) zeros(nvar,nvar*(lags-1))];

if ~PLUG_IN_ONLY && ~CHECK_ONLY
    SRimpf_bound    = NaN(nvar,nstep,nshocks,CurrentDraws,2); % 4th dimension: = 1: min, 2: max
    HRimpf_bound    = NaN(nvar,nstep,nshocks,CurrentDraws,2); % 4th dimension: = 1: min, 2: max

    SIGN_IRFS_SR    = NaN(nvar,nstep,nshocks,CurrentDraws,ndraws_q); % 4th dimension: = 1: min, 2: max        
    SIGN_IRFS_HR    = NaN(nvar,nstep,nshocks,CurrentDraws,ndraws_q); % 4th dimension: = 1: min, 2: max        

    STD_SIGN_IRFS_SR    = NaN(nvar,nstep,nshocks,CurrentDraws,ndraws_q); % 4th dimension: = 1: min, 2: max        
    STD_SIGN_IRFS_HR    = NaN(nvar,nstep,nshocks,CurrentDraws,ndraws_q); % 4th dimension: = 1: min, 2: max        
end

NoTrials=5;

% Initialize
draw_i=0;
HR_rejected_draws=0;
SR_rejected_draws=0;

tmp_scale = 1;



% set invariant variables
ll      = max( reshape(cell2mat(LL(:)),1,[]) );
b       = cell(nshocks,1);
for ss=1:nshocks
    b{ss}       = zeros(nres(ss)*H,1);
end
Aeq     = []; 
beq     = []; 
lb      = []; 
ub      = []; 
%     nonlcon = [];%@norm_check;
% Add Options here! 'active-set', 'trust-region-reflective','interior-point', 
%                   'levenberg-marquardt', 'trust-region-dogleg', 'lm-line-search'.
options = optimset('Display', 'off', 'Algorithm', 'active-set', 'TolCon', 1e-10, 'TolFun', 1e-10, 'TolX', 1e-10, 'MaxIter', 5e3, 'MaxFunEvals', 5e3 ) ;

% this seems obsolete, given that we now focus on LMultipliers
% BindingCutoffs = [1e-8, 1e-6, 1e-4];
% BindingRes_SR=zeros(nvar,nres*H,ndraw_frac,3, 2); % 4th dimension: different cutoffs, 5th dimension: = 1: min, 2: max        
% BindingRes_HR=zeros(nvar,nres*H,ndraw_frac,3, 2); % 4th dimension: different cutoffs, 5th dimension: = 1: min, 2: max        

Empty_Std_Alg_SR=zeros(ndraws, 3, nshocks);
Empty_Std_Alg_HR=zeros(ndraws, 3, nshocks);

if TFP_Lambda~=0
    model_version = model_version*1e4+TFP_Lambda*10+7;
end
if ~DO_SLOPE_W_SR
    model_version = model_version*1e3+5+H-5;
end

%% identification -- both plug-in and loop over parameter draws
if ~CHECK_ONLY
    LL_original = LL;
    LL_past_impact_original = LL_past_impact ;
    if DO_FEVD==0
        if length(HR_MULTIPLE)==1
            IdentificationGivenReducedForm_SoftZero_mshocks;
        else
            IdentificationGivenReducedForm_SoftZero_mshocks_multiple_m;
        end
    else
%         FEVD_horizons = [0 4 8 nstep-1]+1;
%         FEVD_variables = {'Output';'TFP'};
            FEVD_variables = varname;
            FEVD_horizons = 1:nstep;
            fprintf(2, 'can adjust which variables are used in FEVD \n')
        IdentificationGivenReducedForm_SoftZero_mshocks_FEVD;
    end
else
    LL{1} = LL{1}*HR_MULTIPLE(end);
    LL_past_impact{1} = LL_past_impact{1}*HR_MULTIPLE(end);
    IdentificationGivenReducedForm_SoftZero_CheckOnly;
    
    PosteriorChebychevFlag = ChebychevFlag;
    PosteriorAcceptanceRate = (mean(ChebychevFlag(2:end,:)==1 | ChebychevFlag(2:end,:)==3,1));
    
    By = prior_By;
    Bx = prior_Bx;
    omega = prior_omega;
    IdentificationGivenReducedForm_SoftZero_CheckOnly;
    
    PriorAcceptanceRate = (mean(ChebychevFlag(2:end,:)==1 | ChebychevFlag(2:end,:)==3,1));
    
    disp('For comparison: posterior acceptance rate');
    disp(PosteriorAcceptanceRate)
    
    disp('draws with satisfied sufficient condition or fmincon solution (std) - posterior');
    disp(std(PosteriorChebychevFlag(2:end,:)==1 | PosteriorChebychevFlag(2:end,:)==3,1));
    disp(std(PosteriorChebychevFlag(2:end,:)==1 | PosteriorChebychevFlag(2:end,:)==3,1)/sqrt(ndraws));

    
end

% return;
%%
if DO_SAVE && (~CHECK_ONLY)
    if ~ispc()
        LM_fields = fieldnames(LagrangeMultipliers);
        for pp=2:length(LM_fields)
            assignin( 'base', LM_fields{pp}, LagrangeMultipliers.(LM_fields{pp}));
        end
    end
    if DO_FEVD==0
        if max(Do_Cumulative(:))==1
            save(sprintf('%sResults_Model%1.0f_H%d_lvl%s.mat','Results/',model_version,H, Suffix), '-v7.3')
        else
            save(sprintf('%sResults_Model%1.0f_H%d_gr%s.mat','Results/',model_version,H, Suffix), '-v7.3')
        end
    else
        if max(Do_Cumulative(:))==1
            save(sprintf('%sResults_Model%1.0f_H%d_lvl%s.mat','Results/FEVD_',model_version,H, Suffix), '-v7.3')
        else
            save(sprintf('%sResults_Model%1.0f_H%d_gr%s.mat','Results/FEVD_',model_version,H, Suffix), '-v7.3')
        end
    end
end

