clear all;clc;

TimeLabel='Horizon (quarters)';
Plot_Horizon=24;
MyXticks=5:4:Plot_Horizon+1;

%% Added Slope Restrictions
load RawResults/Pooyan_Model113_H5_efficient.mat;

tmp_hr_irfRobust    = squeeze(prctile(HRimpf_bound,[0 1 2.5 5 16 50 84 95 97.5 99 100],4));
tmp_hr_irfEffQ      = squeeze(prctile(SIGN_IRFS_HR(:,:,:),[0 1 2.5 5 16 50 84 95 97.5 99 100],3));


%% Benchmark Restrictions
load RawResults/Results_Model11_H5_gr.mat;

tmp_hr_irf2Robust   = squeeze(prctile(HRimpf_bound,[0 1 2.5 5 16 50 84 95 97.5 99 100],3));
tmp_hr_irf2EffQ     = squeeze(prctile(SIGN_IRFS_HR(:,:,:),[0 1 2.5 5 16 50 84 95 97.5 99 100],3));

color_tmp1 = [ 70 130 180]./255;
color_tmp2 = [  0 191 255]./255;
color_tmp3 = color_tmp1;%[ 65 105 225]./255;
FontSize   = 10;
LineWidth  = 1.0;
tmp_horz   = 0:24;

%% Figure 1
figure('Name','TmpHrvsAddedSlopeR');
for var_ii = [1:4]%1 : 9
    subplot(2,4,var_ii),hold on, color_ii = 0;
    for prct_ii = [2]
        clear alpha
        color_ii =color_ii + 1;
        
        tmp_1 = [tmp_horz flipdim(tmp_horz,2)]';
        tmp_2 = [tmp_hr_irfRobust(var_ii,:,prct_ii,1) flipdim(tmp_hr_irfRobust(var_ii,:,end-prct_ii+1,2),2)]';
        hh_tmp = patch(tmp_1,tmp_2,color_tmp1(color_ii,:),'EdgeColor','None');alpha(.5);
        
        plot(tmp_horz,tmp_horz*0,'k');
        gg_tmp = plot(tmp_horz,tmp_hr_irf2Robust(var_ii,:,prct_ii,1),'Color',color_tmp1(color_ii,:),'LineWidth',LineWidth);
        plot(tmp_horz,tmp_hr_irf2Robust(var_ii,:,end-prct_ii+1,2),'Color',color_tmp1(color_ii,:),'LineWidth',LineWidth);
        set(gca,'FontSize',6,'fontWeight', 'normal','FontName','Times New Roman')
        if var_ii == 1;ylabel(sprintf('Prior-Robust\n'), 'FontSize', FontSize, 'fontWeight', 'normal','FontName','Times New Roman');end
        grid('on');axis('tight')
    end
    box on
    title(varname(var_ii), 'FontSize', FontSize, 'fontWeight', 'normal','FontName','Times New Roman');
end
for var_ii = [1:4]%1 : 9
    subplot(2,4,var_ii+4),hold on, color_ii = 0;
    for prct_ii = [2]
        clear alpha
        color_ii =color_ii + 1;
        
        tmp_1 = [tmp_horz flipdim(tmp_horz,2)]';
        tmp_2 = [tmp_hr_irfEffQ(var_ii,:,prct_ii) flipdim(tmp_hr_irfEffQ(var_ii,:,end-prct_ii+1),2)]';
        hh_tmp = patch(tmp_1,tmp_2,color_tmp1(color_ii,:),'EdgeColor','None');alpha(.5);
        
        plot(tmp_horz,tmp_horz*0,'k');
        gg_tmp = plot(tmp_horz,tmp_hr_irf2EffQ(var_ii,:,prct_ii),'Color',color_tmp1(color_ii,:),'LineWidth',LineWidth);
        plot(tmp_horz,tmp_hr_irf2EffQ(var_ii,:,end-prct_ii+1),'Color',color_tmp1(color_ii,:),'LineWidth',LineWidth);
        set(gca,'FontSize',6,'fontWeight', 'normal','FontName','Times New Roman')
        if var_ii == 1;ylabel(sprintf('Fully-Bayes\n'), 'FontSize', FontSize, 'fontWeight', 'normal','FontName','Times New Roman');end
        if var_ii == 4
            [aaa,leg_hndl] = legend([gg_tmp, hh_tmp], {sprintf('IS for benchmark\n');sprintf('Added slope restriction')}, 'location', 'NorthWest');
            TextInLegend  = findobj(leg_hndl,'Type','Text');    set(TextInLegend,'FontSize',6);
            PAtchInLegend = findobj(leg_hndl,'Type','Patch');   set(PAtchInLegend,'FaceAlpha',0.5);
            legend('boxoff');
        end
        grid on
        axis('tight')
    end
    box on
end
print('-depsc','TmpHrvsAddedSlopeR.eps')
print('-dpdf','TmpHrvsAddedSlopeR.pdf')


figure('Name','TmpHrvsAddedSlopeR1a');
for var_ii = [1:4]%1 : 9
    subplot(2,2,var_ii),hold on, color_ii = 0;
    for prct_ii = [2 5]
        clear alpha
        color_ii = 1;
        
        tmp_1 = [tmp_horz flipdim(tmp_horz,2)]';
        tmp_2 = [tmp_hr_irfRobust(var_ii,:,prct_ii,1) flipdim(tmp_hr_irfRobust(var_ii,:,end-prct_ii+1,2),2)]';
        hh_tmp = patch(tmp_1,tmp_2,color_tmp1(color_ii,:),'EdgeColor','None');
        if prct_ii == 2,alpha(.2),else,alpha(.4),end
        
        plot(tmp_horz,tmp_horz*0,'k');
        if prct_ii == 2
            gg_tmp1 = plot(tmp_horz,tmp_hr_irf2Robust(var_ii,:,prct_ii,1),'Color',color_tmp3(color_ii,:),'LineStyle','-.','LineWidth',LineWidth);
            plot(tmp_horz,tmp_hr_irf2Robust(var_ii,:,end-prct_ii+1,2),'Color',color_tmp3(color_ii,:),'LineStyle','-.','LineWidth',LineWidth);
        else
            gg_tmp2 = plot(tmp_horz,tmp_hr_irf2Robust(var_ii,:,prct_ii,1),'Color',color_tmp3(color_ii,:),'LineStyle','-','LineWidth',LineWidth);
            plot(tmp_horz,tmp_hr_irf2Robust(var_ii,:,end-prct_ii+1,2),'Color',color_tmp3(color_ii,:),'LineStyle','-','LineWidth',LineWidth);
        end
        set(gca,'FontSize',6,'fontWeight', 'normal','FontName','Times New Roman')
        if var_ii == 1;ylabel(sprintf('Prior-Robust\n'), 'FontSize', FontSize, 'fontWeight', 'normal','FontName','Times New Roman');end
        grid('on');axis('tight')
    end
    box on
    title(varname(var_ii), 'FontSize', FontSize, 'fontWeight', 'normal','FontName','Times New Roman');
end
print(gcf, '-depsc', '-r300','TmpHrvsAddedSlopeR1a.eps')


%% Figure 2
figure('Name','TmpHrvsAddedSlopeR2');
for var_ii = [1:4]%1 : 9
    subplot(2,4,var_ii),hold on, color_ii = 0;
    for prct_ii = [2 5]
        clear alpha
        color_ii = 1;
        
        tmp_1 = [tmp_horz flipdim(tmp_horz,2)]';
        tmp_2 = [tmp_hr_irfRobust(var_ii,:,prct_ii,1) flipdim(tmp_hr_irfRobust(var_ii,:,end-prct_ii+1,2),2)]';
        hh_tmp = patch(tmp_1,tmp_2,color_tmp1(color_ii,:),'EdgeColor','None');
        if prct_ii == 2,alpha(.2),else,alpha(.4),end
        
        plot(tmp_horz,tmp_horz*0,'k');
        if prct_ii == 2
            gg_tmp1 = plot(tmp_horz,tmp_hr_irf2Robust(var_ii,:,prct_ii,1),'Color',color_tmp3(color_ii,:),'LineStyle','-.','LineWidth',LineWidth);
            plot(tmp_horz,tmp_hr_irf2Robust(var_ii,:,end-prct_ii+1,2),'Color',color_tmp3(color_ii,:),'LineStyle','-.','LineWidth',LineWidth);
        else
            gg_tmp2 = plot(tmp_horz,tmp_hr_irf2Robust(var_ii,:,prct_ii,1),'Color',color_tmp3(color_ii,:),'LineStyle','-','LineWidth',LineWidth);
            plot(tmp_horz,tmp_hr_irf2Robust(var_ii,:,end-prct_ii+1,2),'Color',color_tmp3(color_ii,:),'LineStyle','-','LineWidth',LineWidth);
        end
        set(gca,'FontSize',6,'fontWeight', 'normal','FontName','Times New Roman')
        set(gca,'XLim',tmp_horz([1 end]),'XTick',[0 MyXticks],'XTickLabel',cellstr(num2str(([1 MyXticks]-1)')),'FontSize',8);
%         set(gg(2), 'YAxisLocation', 'right')
        xlabel(TimeLabel);box('on');
        if var_ii == 1;ylabel(sprintf('Percent\n'), 'FontSize', FontSize, 'fontWeight', 'normal','FontName','Times New Roman');end
        grid('on');axis('tight')
    end
    box on
    title(varname(var_ii), 'FontSize', FontSize, 'fontWeight', 'normal','FontName','Times New Roman');
end

saveTightFigure(gcf,'Graphs/SlopeVsBench_td')
