%% I. Set color details
% -------------------------------------------------------------------------
DO_SAVE  = 1;
FontSize = 12;

GridRGB = [0 0 0]+.3;

RGB     = [.7 .7 .7]+.2;        RGB_E   = 'none';
SRRGB   = [255,160,122]/255;    SRRGB_E = 'none';
SR_RGB  = [139,  0,  0;
    220, 20, 60;
    240,128,128]/255;
HR_RGB  = [  0,  0,139;
    65,105,225;
    135,206,235]/255;
HRRGB   = [220, 20, 60]/255;    HRRGB_E = 'none';

IS_HRRGB   = [  0,191,255]/255;
IS_SRRGB   = [240,128,128]/255;


%% Figure set 1: Density of Plug-in / Identified set
% =========================================================================
if ~ONLY_ALG2 % for Alg1 & Alg 2
    
    F_SR    = cell(nvar,1);
    XI_SR   = cell(nvar,1);
    F_HR    = cell(nvar,1);
    XI_HR   = cell(nvar,1);
    
    SameIDX             =~squeeze(isnan(HRimpf_bound(1,1,:,1)));
    Robust_SRimpf_tmpGR = squeeze(prctile(SRimpf_bound(:,:,SameIDX,:), [1 2.5 5 16 50 84 95 97.5 99],3));
    Robust_HRimpf_tmpGR = squeeze(prctile(HRimpf_bound(:,:,SameIDX,:), [1 2.5 5 16 50 84 95 97.5 99],3));
    Robust_SRimpf_Extremes = squeeze(prctile(SRimpf_bound(:,:,SameIDX,:), [0 100],3));
    Robust_HRimpf_Extremes = squeeze(prctile(HRimpf_bound(:,:,SameIDX,:), [0 100],3));
    
    SameIDX             =~squeeze(isnan(SIGN_IRFS_HR(1,1,:,1)));
    Bayes_SRimpf_tmpGR  = squeeze(prctile(reshape(SIGN_IRFS_SR(:,:,SameIDX,:), [nvar, nstep, sum(SameIDX)*ndraws_q]), [1 2.5 5 16 50 84 95 97.5 99],3));
    Bayes_HRimpf_tmpGR  = squeeze(prctile(reshape(SIGN_IRFS_HR(:,:,SameIDX,:), [nvar, nstep, sum(SameIDX)*ndraws_q]), [1 2.5 5 16 50 84 95 97.5 99],3));
    
    for nn = 1 : nvar
        [F_SR{nn}, XI_SR{nn}] = ksdensity( reshape(SIGN_IRFS_SR(nn,density_hh,SameIDX,:), 1,[]), 'Function','pdf', 'Support', [min(squeeze(SRimpf_bound(nn,density_hh,SameIDX,1))),max(squeeze(SRimpf_bound(nn,density_hh,SameIDX,2)))]);
        [F_HR{nn}, XI_HR{nn}] = ksdensity( reshape(SIGN_IRFS_HR(nn,density_hh,SameIDX,:), 1,[]), 'Function','pdf', 'Support', [min(squeeze(HRimpf_bound(nn,density_hh,SameIDX,1))),max(squeeze(HRimpf_bound(nn,density_hh,SameIDX,2)))]);
        
        figure; orient('Landscape'); hold all; grid on;
        
        leg_h(1) = plot(XI_SR{nn},F_SR{nn},'--', 'LineWidth', 3, 'Color', SR_RGB(2,:));
        leg_h(2) = plot(XI_HR{nn},F_HR{nn},'-', 'LineWidth', 3, 'Color', HR_RGB(2,:));
        
        %         leg_h(3) = plot([Robust_SRimpf_tmpGR(nn,hh,1,1) Robust_SRimpf_tmpGR(nn,hh,end,2)],[.98 .98]*max(ylim),'Color',SR_RGB(1,:),'linewidth',8);
        %         leg_h(4) = plot([Robust_HRimpf_tmpGR(nn,hh,1,1) Robust_HRimpf_tmpGR(nn,hh,end,2)],[.95 .95]*max(ylim),'Color',HR_RGB(1,:),'linewidth',8);
        leg_h(3) = plot([Robust_SRimpf_Extremes(nn,density_hh,1,1) Robust_SRimpf_Extremes(nn,density_hh,end,2)],-[.04 .04]*max(ylim),'Color',SR_RGB(1,:),'linewidth',8);
        leg_h(4) = plot([Robust_HRimpf_Extremes(nn,density_hh,1,1) Robust_HRimpf_Extremes(nn,density_hh,end,2)],-[.08 .08]*max(ylim),'Color',HR_RGB(1,:),'linewidth',8);
        
        title(varname{nn}); ylabel('density'); box('on')
        set(findall(gcf, '-property', 'FontSize'), 'FontSize', FontSize, 'fontWeight', 'normal','FontName','Times New Roman');
        set(findall(gcf,'type','axes'),'ycolor',GridRGB,'xcolor',GridRGB,'GridLineStyle','-','LineWidth',.5,'FontSize',FontSize);
        
%         leg_ax=legend(leg_h,'SR_{FullyBayesian}','HR_{FullyBayesian}','SR_{PriorRobustBound}','HR_{PriorRobustBound}',...
%             'Location','best','Orientation','vertical');
        % LEG = findobj(leg_ax,'type','text');
%         set(leg_ax,'FontSize', FontSize+4, 'fontWeight', 'normal','FontName','Times New Roman')
%         legend('boxoff');
        
        if DO_SAVE
            print(gcf, '-depsc', '-r300',sprintf('%sNewStyleNumericalBoundsVariable_%d_Model%1.0f_H%d_density.eps',save_path_bound,nn, model_version,H))
        end;
        % pause
%         close all
        
    end;
else
    SameIDX=~squeeze(isnan(SIGN_IRFS_HR(1,1,:,1)));
    Bayes_SRimpf_tmpGR    = squeeze(prctile(reshape(SIGN_IRFS_SR(:,:,SameIDX,:), [nvar, nstep, sum(SameIDX)*ndraws_q]), [1 2.5 5 16 50 84 95 97.5 99],3));
    Bayes_HRimpf_tmpGR    = squeeze(prctile(reshape(SIGN_IRFS_HR(:,:,SameIDX,:), [nvar, nstep, sum(SameIDX)*ndraws_q]), [1 2.5 5 16 50 84 95 97.5 99],3));
end;

%%
if DO_MULTIPLIER
    q_MULTIPLIER_HR= (1/defense_share) * (cumsum(squeeze(SIGN_IRFS_HR(sel_gdp_var,:,:,:)).*(discount_factor.^(0:nstep-1)'),1) ) ./(cumsum(squeeze(SIGN_IRFS_HR(sel_def_var,:,:,:)).*(discount_factor.^(0:nstep-1)') ,1)) ;
    q_MULTIPLIER_SR= (1/defense_share) * (cumsum(squeeze(SIGN_IRFS_SR(sel_gdp_var,:,:,:)).*(discount_factor.^(0:nstep-1)'),1) ) ./(cumsum(squeeze(SIGN_IRFS_SR(sel_def_var,:,:,:)).*(discount_factor.^(0:nstep-1)') ,1)) ;
    Bayes_SR_Multiplier = prctile(reshape(q_MULTIPLIER_SR(:,SameIDX,:), [nstep, sum(SameIDX)*ndraws_q]), [1 2.5 5 16 50 84 95 97.5 99],2);
    Bayes_HR_Multiplier = prctile(reshape(q_MULTIPLIER_HR(:,SameIDX,:), [nstep, sum(SameIDX)*ndraws_q]), [1 2.5 5 16 50 84 95 97.5 99],2);
    
%     sel_hours_var=(strcmp('Hours', IncludeSeriesNames));
%     q_LAB_PROD_HR= squeeze(SIGN_IRFS_HR(sel_gdp_var,:,:,:))-squeeze(SIGN_IRFS_HR(sel_hours_var,:,:,:));
%     Bayes_HR_LAB_PROD= prctile(reshape(q_LAB_PROD_HR(:,SameIDX,:), [nstep, sum(SameIDX)*ndraws_q]), [1 2.5 5 16 50 84 95 97.5 99],2);

end;

%% Algorithm 1: Prior-robust posterior bounds
% =========================================================================
close all;

tmpa = [1:nstep nstep:-1:1]';

if ~ONLY_ALG2
    clear tmp_lim hub g h hlb tmpHR tmpSR tmp_lim
    for ii = 1 : nvar
        figure; orient('Landscape'); clear g h;
        
        gg(1) = subplot(1,2,1); hold('on');
        % Part 1: Outer Bounds
        tmpSR = [squeeze(Robust_SRimpf_tmpGR(ii,:,1+3,1))';flipdim(squeeze(Robust_SRimpf_tmpGR(ii,:,end-3,2))',1)];
        g(1) = patch(tmpa,tmpSR,RGB,'edgecolor',RGB_E,'HandleVisibility','on','LineWidth',2);
        
        % Part 2: Lower Bounds
        for jj = 1 : 3
            tmpSR = [squeeze(Robust_SRimpf_tmpGR(ii,:,1,1))';flipdim(squeeze(Robust_SRimpf_tmpGR(ii,:,5-jj,1))',1)];
            hlb(jj)=patch(tmpa,tmpSR,SR_RGB(jj,:),'edgecolor',RGB_E,'HandleVisibility','on','LineWidth',2);
            
        end
        
        % Part 3: Upper Bounds
        for jj = 1 : 3
            tmpSR = [squeeze(Robust_SRimpf_tmpGR(ii,:,end,2))';flipdim(squeeze(Robust_SRimpf_tmpGR(ii,:,end-4+jj,2))',1)];
            hub(jj)=patch(tmpa,tmpSR,SR_RGB(jj,:),'edgecolor',RGB_E,'HandleVisibility','on','LineWidth',2);
        end
        plot(1:nstep,zeros(1,nstep),'k','LineWidth',1);
        grid('on')
        title(sprintf('Sign Restrictions'),'FontSize',10,'FontName','Serif','FontWeight','Bold');
        % plot(1:25,squeeze((SRimpf_tmp1(ii,:,1:4,1))),'r',1:25,squeeze((SRimpf_tmp1(ii,:,6:end,2))),'b')
        xlabel(TimeLabel);ylabel(UnitLabel{ii});box('on');
        
        ylim_tmp = get(gca,'YLim');
        %--------------------------------------------------------------------------
        %--------------------------------------------------------------------------
        gg(2)=subplot(1,2,2);hold('on');
        % Part 1: Outer Bounds
        tmpHR = [squeeze(Robust_HRimpf_tmpGR(ii,:,1+3,1))';flipdim(squeeze(Robust_HRimpf_tmpGR(ii,:,end-3,2))',1)];
        g(2)=patch(tmpa,tmpHR,RGB,'edgecolor',RGB_E,  'HandleVisibility','on','LineWidth',2);
        % plot(1:nstep,zeros(1,nstep),'k','LineWidth',1);
        % Part 2: Lower Bounds
        for jj = 1 : 3
            tmpHR = [squeeze(Robust_HRimpf_tmpGR(ii,:,1,1))';flipdim(squeeze(Robust_HRimpf_tmpGR(ii,:,5-jj,1))',1)];
            hlb(jj)=patch(tmpa,tmpHR,HR_RGB(jj,:),'edgecolor',RGB_E,'HandleVisibility','on','LineWidth',2);
            
        end
        % Part 3: Upper Bounds
        for jj = 1 : 3
            tmpHR = [squeeze(Robust_HRimpf_tmpGR(ii,:,end,2))';flipdim(squeeze(Robust_HRimpf_tmpGR(ii,:,end-4+jj,2))',1)];
            hup(jj)=patch(tmpa,tmpHR,HR_RGB(jj,:),'edgecolor',RGB_E,'HandleVisibility','on','LineWidth',2);
            
        end
        plot(1:nstep,zeros(1,nstep),'k','LineWidth',1); grid('on')
        title(sprintf('Heterogeneity Restrictions'),'FontSize',10,'FontName','Serif','FontWeight','Bold');
        ylim_tmp = [ylim_tmp get(gca,'YLim')];
        tmp_lim = [min(ylim_tmp(:)) max(ylim_tmp(:))];
%         set(gg,'XLim',[1 Plot_Horizon+1],'XTick',[1 7:6:Plot_Horizon-1],'XTickLabel',cellstr(num2str((0:3:Plot_Horizon)')),'YLim',[tmp_lim(1) tmp_lim(2)],'FontSize',8)
        set(gg,'XLim',[1 Plot_Horizon+1],'XTick',[0 MyXticks],'XTickLabel',cellstr(num2str(([1 MyXticks]-1)')),'YLim',[tmp_lim(1) tmp_lim(2)],'FontSize',8);
        set(gg(2), 'YAxisLocation', 'right')
        xlabel(TimeLabel);box('on');
        set(findall(gcf, '-property', 'FontSize'), 'FontSize', FontSize, 'fontWeight', 'normal','FontName','Times New Roman')
        set(findall(gcf,'type','axes'),'ycolor',GridRGB,'xcolor',GridRGB,'GridLineStyle','-','LineWidth',.5,'FontSize',FontSize)
        set(gg, 'YMinorGrid', 'on')        
        
        %--------------------------------------------------------------------------
        % Comparison with posterior mean
        %--------------------------------------------------------------------------
        subplot(1,2,1); 
        plot(1:nstep, squeeze( Mean_SRimpf_bound(ii,:,:) ), '--k', 'LineWidth', 2);
        subplot(1,2,2); 
        plot(1:nstep, squeeze( Mean_HRimpf_bound(ii,:,:) ), '--k', 'LineWidth', 2);
        %--------------------------------------------------------------------------
        %--------------------------------------------------------------------------
        
        if DO_SAVE
            if max(Do_Cumulative(:))==1
                print(gcf, '-depsc', '-r300',sprintf('%sNewStyleNumericalBoundsVariable_%d_Model%1.0f_H%d_lvl.eps',save_path_bound,ii, model_version,H))
            else
                print(gcf, '-depsc', '-r300',sprintf('%sNewStyleNumericalBoundsVariable_%d_Model%1.0f_H%d_TD.eps',save_path_bound,ii, model_version,H))
            end;
            %         print(gcf, '-dpdf', '-r300',sprintf('%sNumericalBoundsVariable_%d_TD.pdf',save_path_bound,ii))
        end


        % close all;
        clear tmp_lim hub g h hlb tmpHR tmpSR tmp_lim
        
    end
    
    SetReductionPercent=-100*([Robust_HRimpf_tmpGR(negSR_index<=NoMacroVars,:,[1],1); Robust_HRimpf_tmpGR(posSR_index<=NoMacroVars,:,[9],2)] ...
        ./[Robust_SRimpf_tmpGR(negSR_index<=NoMacroVars,:,[1],1); Robust_SRimpf_tmpGR(posSR_index<=NoMacroVars,:,[9],2)]-1);
    SetReductionVarnames=[varname(posSR_index<=NoMacroVars); varname(negSR_index<=NoMacroVars)];
    
    TableSetReduction=[char(regexprep(SetReductionVarnames', '_', ' ')) num2str(SetReductionPercent, '& %1.1f') repmat('\\ ', NoMacroVars,1)];
    if DO_SAVE
        PreFixName = sprintf('%sNumericalBoundsVariable_Model%1.0f_H%d',save_path_bound, model_version,H);
        
        my_fid = fopen( [PreFixName '_HR_B_IRF_Reduction.tex'], 'w');
        WriteTable=cellstr(TableSetReduction);
        fprintf(my_fid, '%s \n', WriteTable{:});
        fclose(my_fid);
    end;

    SetReductionPercent=-100*([Robust_HRimpf_tmpGR(negSR_index>NoMacroVars,:,[1],1); Robust_HRimpf_tmpGR(posSR_index>NoMacroVars,:,[9],2)] ...
        ./[Robust_SRimpf_tmpGR(negSR_index>NoMacroVars,:,[1],1); Robust_SRimpf_tmpGR(posSR_index>NoMacroVars,:,[9],2)]-1);
    SetReductionVarnames=[varname(posSR_index>NoMacroVars); varname(negSR_index>NoMacroVars)];
    
    TableSetReduction=[char(regexprep(SetReductionVarnames', '_', ' ')) num2str(SetReductionPercent, '& %1.1f') repmat('\\ ', nvar-NoMacroVars,1)];
    if DO_SAVE
        PreFixName = sprintf('%sNumericalBoundsVariable_Model%1.0f_H%d',save_path_bound, model_version,H);
        
        my_fid = fopen( [PreFixName '_HR_B_IRF_Reduction_Micro.tex'], 'w');
        WriteTable=cellstr(TableSetReduction);
        fprintf(my_fid, '%s \n', WriteTable{:});
        fclose(my_fid);
    end;
    

end;


%% Algorithm 2: Fully Bayesian posterior bounds
% =========================================================================
% Plot_Horizon=24;
close all;
tmpa = [1:nstep nstep:-1:1]';

if ~ONLY_ALG2
    clear tmp_lim hub g h hlb tmpHR tmpSR tmp_lim
    for ii = 1 : nvar
        figure; orient('Landscape'); clear g h;
         MinMaxSR = [squeeze(Robust_SRimpf_tmpGR(ii,:,1,1))',squeeze(Robust_SRimpf_tmpGR(ii,:,end,2))'];
         MinMaxHR = [squeeze(Robust_HRimpf_tmpGR(ii,:,1,1))',squeeze(Robust_HRimpf_tmpGR(ii,:,end,2))'];
        
        gg(1) = subplot(1,2,1); hold('on');
        
        % Part 2: Lower Bounds
        for jj = 1 : 3
            tmpSR = [squeeze(Bayes_SRimpf_tmpGR(ii,:,jj))';flipdim(squeeze(Bayes_SRimpf_tmpGR(ii,:,end-jj+1))',1)];
            hlb(1,jj)=patch(tmpa,tmpSR,SR_RGB(4-jj,:),'edgecolor',RGB_E,'HandleVisibility','on','LineWidth',2);
            
        end
        % Part 1: Outer Bounds
        tmpSR = [squeeze(Bayes_SRimpf_tmpGR(ii,:,4))';flipdim(squeeze(Bayes_SRimpf_tmpGR(ii,:,end-3))',1)];
        g(1) = patch(tmpa,tmpSR,RGB,'edgecolor',RGB_E,'HandleVisibility','on','LineWidth',2);
%         Alg1_bounds_SR=plot(1:nstep, MinMaxSR, '--', 'Color', SR_RGB(1,:), 'LineWidth', 3);       
   
%         % Part 3: Upper Bounds
%         for jj = 2 : 4
%             tmpSR = [squeeze(Bayes_SRimpf_tmpGR(ii,:,jj))';flipdim(squeeze(Bayes_SRimpf_tmpGR(ii,:,end-jj+1))',1)];
%             hub(jj)=patch(tmpa,tmpSR,SR_RGB(jj,:),'edgecolor',RGB_E,'HandleVisibility','on','LineWidth',2);
%         end
        plot(1:nstep,zeros(1,nstep),'k','LineWidth',1);
        grid('on')
        title(sprintf('Sign Restrictions'),'FontSize',10,'FontName','Serif','FontWeight','Bold');
        % plot(1:25,squeeze((SRimpf_tmp1(ii,:,1:4,1))),'r',1:25,squeeze((SRimpf_tmp1(ii,:,6:end,2))),'b')
        xlabel(TimeLabel);ylabel(UnitLabel{ii});box('on');
        
        ylim_tmp = get(gca,'YLim');
        %--------------------------------------------------------------------------
        %--------------------------------------------------------------------------
        gg(2)=subplot(1,2,2);hold('on');
        % Part 1: Outer Bounds
   
        % plot(1:nstep,zeros(1,nstep),'k','LineWidth',1);
        % Part 2: Lower Bounds
        for jj = 1:3
            tmpHR = [squeeze(Bayes_HRimpf_tmpGR(ii,:,jj))';flipdim(squeeze(Bayes_HRimpf_tmpGR(ii,:,end-jj+1))',1)];
            hlb(2,jj)=patch(tmpa,tmpHR,HR_RGB(4-jj,:),'edgecolor',RGB_E,'HandleVisibility','on','LineWidth',2);
            
        end
        tmpHR = [squeeze(Bayes_HRimpf_tmpGR(ii,:,4))';flipdim(squeeze(Bayes_HRimpf_tmpGR(ii,:,end-3))',1)];
        g(2)=patch(tmpa,tmpHR,RGB,'edgecolor',RGB_E,  'HandleVisibility','on','LineWidth',2);
%         % Part 3: Upper Bounds
%         for jj = 2 : 4
%             tmpHR = [squeeze(Bayes_HRimpf_tmpGR(ii,:,jj))';flipdim(squeeze(Bayes_HRimpf_tmpGR(ii,:,end-jj+1))',1)];
%             hup(jj)=patch(tmpa,tmpHR,HR_RGB(jj,:),'edgecolor',RGB_E,'HandleVisibility','on','LineWidth',2);
%             
%         end
        plot(1:nstep,zeros(1,nstep),'k','LineWidth',1); grid('on')
%         Alg1_bounds_HR=plot(1:nstep, MinMaxHR, '--', 'Color', HR_RGB(1,:), 'LineWidth', 3);

        title(sprintf('Heterogeneity Restrictions'),'FontSize',10,'FontName','Serif','FontWeight','Bold');
        ylim_tmp = [ylim_tmp get(gca,'YLim')];
        tmp_lim = [min(ylim_tmp(:)) max(ylim_tmp(:))];
        set(gg,'XLim',[1 Plot_Horizon+1],'XTick',[0 MyXticks],'XTickLabel',cellstr(num2str(([1 MyXticks]-1)')),'YLim',[tmp_lim(1) tmp_lim(2)],'FontSize',8);
        set(gg(2), 'YAxisLocation', 'right')
        xlabel(TimeLabel);box('on');
        set(findall(gcf, '-property', 'FontSize'), 'FontSize', FontSize, 'fontWeight', 'normal','FontName','Times New Roman')
        set(findall(gcf,'type','axes'),'ycolor',GridRGB,'xcolor',GridRGB,'GridLineStyle','-','LineWidth',.5,'FontSize',FontSize)
%         set(gg, 'YMinorGrid', 'on')        
        
        if DO_SAVE
            print(gcf, '-depsc', '-r300',sprintf('%sNewStyleNumericalBoundsVariable_%d_Model%1.0f_H%d_Bayes.eps',save_path_bound,ii, model_version,H))
            %         print(gcf, '-dpdf', '-r300',sprintf('%sNumericalBoundsVariable_%d_TD.pdf',save_path_bound,ii))
        end
        
%         delete(Alg1_bounds_HR);
%         delete(Alg1_bounds_SR);
        delete(hlb(:,1))
        set(gg, 'YlimMode', 'Auto');
        ylim_tmp = [ylim_tmp get(gca,'YLim')];
        tmp_lim = [min(min(cell2mat(get(gg, 'Ylim')))) max(max(cell2mat(get(gg, 'Ylim'))))];
        set(gg,'XLim',[1 Plot_Horizon+1],'XTick',[0 MyXticks],'XTickLabel',cellstr(num2str(([1 MyXticks]-1)')),'YLim',[tmp_lim(1) tmp_lim(2)],'FontSize',8);
        set(findall(gcf, '-property', 'FontSize'), 'FontSize', FontSize, 'fontWeight', 'normal','FontName','Times New Roman')
        set(findall(gcf,'type','axes'),'ycolor',GridRGB,'xcolor',GridRGB,'GridLineStyle','-','LineWidth',.5,'FontSize',FontSize)
        
        if DO_SAVE
            print(gcf, '-depsc', '-r300',sprintf('%sNewStyleNumericalBoundsVariable_%d_Model%1.0f_H%d_B_narrow.eps',save_path_bound,ii, model_version,H))
            %         print(gcf, '-dpdf', '-r300',sprintf('%sNumericalBoundsVariable_%d_TD.pdf',save_path_bound,ii))
        end
        
        % close all;
        clear tmp_lim hub g h hlb tmpHR tmpSR tmp_lim
        % close all;
        clear tmp_lim hub g h hlb tmpHR tmpSR tmp_lim
        
    end
    
    SetReductionPercent=-100*([Bayes_HRimpf_tmpGR(negSR_index<=NoMacroVars,:,[1]); Bayes_HRimpf_tmpGR(posSR_index<=NoMacroVars,:,[9])] ...
        ./[Bayes_SRimpf_tmpGR(negSR_index<=NoMacroVars,:,[1]); Bayes_SRimpf_tmpGR(posSR_index<=NoMacroVars,:,[9])]-1);
    SetReductionVarnames=[varname(posSR_index<=NoMacroVars); varname(negSR_index<=NoMacroVars)];
    
    TableSetReduction=[char(regexprep(SetReductionVarnames', '_', ' ')) num2str(SetReductionPercent, '& %1.1f') repmat('\\ ', NoMacroVars,1)];
    if DO_SAVE
        PreFixName = sprintf('%sNumericalBoundsVariable_Model%1.0f_H%d',save_path_bound, model_version,H);
        
        my_fid = fopen( [PreFixName '_HR_B_IRF_Reduction_Bayes.tex'], 'w');
        WriteTable=cellstr(TableSetReduction);
        fprintf(my_fid, '%s \n', WriteTable{:});
        fclose(my_fid);
    end;

    SetReductionPercent=-100*([Bayes_HRimpf_tmpGR(negSR_index>NoMacroVars,:,[1]); Bayes_HRimpf_tmpGR(posSR_index>NoMacroVars,:,[9])] ...
        ./[Bayes_SRimpf_tmpGR(negSR_index>NoMacroVars,:,[1]); Bayes_SRimpf_tmpGR(posSR_index>NoMacroVars,:,[9])]-1);
    SetReductionVarnames=[varname(posSR_index>NoMacroVars); varname(negSR_index>NoMacroVars)];
    
    TableSetReduction=[char(regexprep(SetReductionVarnames', '_', ' ')) num2str(SetReductionPercent, '& %1.1f') repmat('\\ ', nvar-NoMacroVars,1)];
    if DO_SAVE
        PreFixName = sprintf('%sNumericalBoundsVariable_Model%1.0f_H%d',save_path_bound, model_version,H);
        
        my_fid = fopen( [PreFixName '_HR_B_IRF_Reduction_Micro_Bayes.tex'], 'w');
        WriteTable=cellstr(TableSetReduction);
        fprintf(my_fid, '%s \n', WriteTable{:});
        fclose(my_fid);
    end;
    
    %%%% Multipliers
    if DO_MULTIPLIER
        figure; orient('Landscape'); clear g h;

        gg(1) = subplot(1,2,1); hold('on');

        % Part 2: Lower Bounds
        for jj = 1 : 3
            tmpSR = [squeeze(Bayes_SR_Multiplier(:,jj));flipdim(squeeze(Bayes_SR_Multiplier(:,end-jj+1)),1)];
            hlb(1,jj)=patch(tmpa,tmpSR,SR_RGB(4-jj,:),'edgecolor',RGB_E,'HandleVisibility','on','LineWidth',2);

        end
        % Part 1: Outer Bounds
        tmpSR = [(Bayes_SR_Multiplier(:,4));flipdim((Bayes_SR_Multiplier(:,end-3)),1)];
        g(1) = patch(tmpa,tmpSR,RGB,'edgecolor',RGB_E,'HandleVisibility','on','LineWidth',2);
%         Alg1_bounds_SR=plot(1:nstep, MinMaxSR, '--', 'Color', SR_RGB(1,:), 'LineWidth', 3);        
    %         % Part 3: Upper Bounds
    %         for jj = 2 : 4
    %             tmpSR = [squeeze(Bayes_SRimpf_tmpGR(:,jj))';flipdim(squeeze(Bayes_SRimpf_tmpGR(:,end-jj+1))',1)];
    %             hub(jj)=patch(tmpa,tmpSR,SR_RGB(jj,:),'edgecolor',RGB_E,'HandleVisibility','on','LineWidth',2);
    %         end
        plot(1:nstep,zeros(1,nstep),'k','LineWidth',1);
        grid('on')
        title(sprintf('\nSign Restrictions:\n Multiplier'),'FontSize',10,'FontName','Serif','FontWeight','Bold');
        % plot(1:25,squeeze((SRimpf_tmp1(:,1:4,1))),'r',1:25,squeeze((SRimpf_tmp1(:,6:end,2))),'b')
        xlabel(TimeLabel);box('on');

        ylim_tmp = get(gca,'YLim');
        %--------------------------------------------------------------------------
        %--------------------------------------------------------------------------
        gg(2)=subplot(1,2,2);hold('on');
        % Part 1: Outer Bounds
        % plot(1:nstep,zeros(1,nstep),'k','LineWidth',1);
        % Part 2: Lower Bounds
        for jj = 1 : 3
            tmpHR = [squeeze(Bayes_HR_Multiplier(:,jj));flipdim(squeeze(Bayes_HR_Multiplier(:,end-jj+1)),1)];
            hlb(2,jj)=patch(tmpa,tmpHR,HR_RGB(4-jj,:),'edgecolor',RGB_E,'HandleVisibility','on','LineWidth',2);

        end
        tmpHR = [squeeze(Bayes_HR_Multiplier(:,4));flipdim(squeeze(Bayes_HR_Multiplier(:,end-3)),1)];
        g(2)=patch(tmpa,tmpHR,RGB,'edgecolor',RGB_E,  'HandleVisibility','on','LineWidth',2);
    %         % Part 3: Upper Bounds
    %         for jj = 2 : 4
    %             tmpHR = [squeeze(Bayes_HRimpf_tmpGR(:,jj))';flipdim(squeeze(Bayes_HRimpf_tmpGR(:,end-jj+1))',1)];
    %             hup(jj)=patch(tmpa,tmpHR,HR_RGB(jj,:),'edgecolor',RGB_E,'HandleVisibility','on','LineWidth',2);
    %             
    %         end
        plot(1:nstep,zeros(1,nstep),'k','LineWidth',1); grid('on')
%         Alg1_bounds_HR=plot(1:nstep, MinMaxHR, '--', 'Color', HR_RGB(1,:), 'LineWidth', 3);

        title(sprintf('\nHeterogeneity Restrictions:\n Multiplier'),'FontSize',10,'FontName','Serif','FontWeight','Bold');
        ylim_tmp = [ylim_tmp get(gca,'YLim')];
        tmp_lim = [min(ylim_tmp(:)) max(ylim_tmp(:))];
        set(gg,'XLim',[1 Plot_Horizon+1],'XTick',[0 MyXticks],'XTickLabel',cellstr(num2str(([1 MyXticks]-1)')),'YLim',[tmp_lim(1) tmp_lim(2)],'FontSize',8);
        set(gg(2), 'YAxisLocation', 'right')
        xlabel(TimeLabel);box('on');
        set(findall(gcf, '-property', 'FontSize'), 'FontSize', FontSize, 'fontWeight', 'normal','FontName','Times New Roman')
        set(findall(gcf,'type','axes'),'ycolor',GridRGB,'xcolor',GridRGB,'GridLineStyle','-','LineWidth',.5,'FontSize',FontSize)
%         set(gg, 'YMinorGrid', 'on')        

        if DO_SAVE
            print(gcf, '-depsc', '-r300',sprintf('%sNewStyleNumericalBoundsVariable_%d_Model%1.0f_H%d_Bayes.eps',save_path_bound,0, model_version,H))
            %         print(gcf, '-dpdf', '-r300',sprintf('%sNumericalBoundsVariable_%d_TD.pdf',save_path_bound,ii))
        end

%         delete(Alg1_bounds_HR);
%         delete(Alg1_bounds_SR);
        delete(hlb(:,1))
        set(gg, 'YlimMode', 'Auto');
        ylim_tmp = [ylim_tmp get(gca,'YLim')];
        tmp_lim = [min(min(cell2mat(get(gg, 'Ylim')))) max(max(cell2mat(get(gg, 'Ylim'))))];
        set(gg,'XLim',[1 Plot_Horizon+1],'XTick',[0 MyXticks],'XTickLabel',cellstr(num2str(([1 MyXticks]-1)')),'YLim',[tmp_lim(1) tmp_lim(2)],'FontSize',8);
        set(findall(gcf, '-property', 'FontSize'), 'FontSize', FontSize, 'fontWeight', 'normal','FontName','Times New Roman')
        set(findall(gcf,'type','axes'),'ycolor',GridRGB,'xcolor',GridRGB,'GridLineStyle','-','LineWidth',.5,'FontSize',FontSize)
%         set(gg, 'YMinorGrid', 'on')        

        if DO_SAVE
            print(gcf, '-depsc', '-r300',sprintf('%sNewStyleNumericalBoundsVariable_%d_Model%1.0f_H%d_B_narrow.eps',save_path_bound,0, model_version,H))
            %         print(gcf, '-dpdf', '-r300',sprintf('%sNumericalBoundsVariable_%d_TD.pdf',save_path_bound,ii))
        end

        
        delete(hlb)
        set(g, 'edgecolor', ones(1,3)/3); % color the edges dark gray for better visibility
        set(gg, 'YlimMode', 'Auto');
        ylim_tmp = [ylim_tmp get(gca,'YLim')];
        tmp_lim = [min(min(cell2mat(get(gg, 'Ylim')))) max(max(cell2mat(get(gg, 'Ylim'))))];
        set(gg,'XLim',[1 Plot_Horizon+1],'XTick',[0 MyXticks],'XTickLabel',cellstr(num2str(([1 MyXticks]-1)')),'YLim',[tmp_lim(1) tmp_lim(2)],'FontSize',8);
        set(findall(gcf, '-property', 'FontSize'), 'FontSize', FontSize, 'fontWeight', 'normal','FontName','Times New Roman')
        set(findall(gcf,'type','axes'),'ycolor',GridRGB,'xcolor',GridRGB,'GridLineStyle','-','LineWidth',.5,'FontSize',FontSize)
%         set(gg, 'YMinorGrid', 'on')        

        %--------------------------------------------------------------------------
        % Comparison with posterior mean
        %--------------------------------------------------------------------------
        subplot(1,2,1); 
        plot(1:nstep, squeeze( prctile(MEAN_q_MULTIPLIER_SR(:,:), [16 68 ],2) ), '--k', 'LineWidth', 2);
        subplot(1,2,2); 
        plot(1:nstep, squeeze( prctile(MEAN_q_MULTIPLIER_HR(:,:), [16 68 ],2) ), '--k', 'LineWidth', 2);
        %--------------------------------------------------------------------------
        %--------------------------------------------------------------------------

        if DO_SAVE
            print(gcf, '-depsc', '-r300',sprintf('%sNewStyleNumericalBoundsVariable_%d_Model%1.0f_H%d_B_narrowest.eps',save_path_bound,0, model_version,H))
            %         print(gcf, '-dpdf', '-r300',sprintf('%sNumericalBoundsVariable_%d_TD.pdf',save_path_bound,ii))
        end
        % close all;
        clear tmp_lim hub g h hlb tmpHR tmpSR tmp_lim
    end;
    
end;

%% Count of binding restrictions
close all

BindingCount = cell(2,1);
BindingCount{1} = zeros(nres, nvar,3,2);
BindingCount{2} = zeros(nres, nvar,3,2);
for bb = 1:2
    for nn=1:nvar
        % 1st: sum incidents over all draws
        % 2nd: sum incidents over restriction horizon
        BindingCount{2}(:,nn,:,bb) = BindingCount{2}(:,nn,:,bb) + sum(reshape(sum(squeeze(BindingRes_HR( nn, :, SameIDX, :, bb)),2), [nres, H, 3]),2) / sum(SameIDX); 
        BindingCount{1}(:,nn,:,bb) = BindingCount{1}(:,nn,:,bb) + sum(reshape(sum(squeeze(BindingRes_SR( nn, :, SameIDX, :, bb)),2), [nres, H, 3]),2) / sum(SameIDX); 
    end;
end;

FormattedLabels=RestrictionLabels(:,1);
HR_idx=cellfun(@isempty, strfind(RestrictionLabels(:,1),'>0'));
FormattedLabels(HR_idx)=regexprep(FormattedLabels(HR_idx), '>', '$>\\lambda \\times$');

    % overall
    PreFixName = sprintf('%sBindingRes_Model%1.0f_H%d',[save_path_bound 'Both_'], model_version,H);
    MyTable=[char(RestrictionLabels{:,1}), num2str(squeeze(sum(BindingCount{1}(:,:,3,1),2))/nvar, '& %1.2f'), ...
        num2str(squeeze(sum(BindingCount{2}(:,:,3,1),2))/nvar, '& %1.2f '), ...
        num2str(squeeze(sum(BindingCount{1}(:,:,3,2),2))/nvar, '& %1.2f'), ...
        num2str(squeeze(sum(BindingCount{2}(:,:,3,2),2))/nvar, '& %1.2f \\\\')];
    if DO_SAVE
%         PreFixName = sprintf('%sNumericalBoundsVariable_Model%1.0f_H%d',save_path_bound, model_version,H);

        my_fid = fopen( [PreFixName '_all.tex'], 'w');
        WriteTable=cellstr(MyTable);
        WriteTable=regexprep(WriteTable, '>0', '$>0$');
        WriteTable=regexprep(WriteTable, '<0', '$<0$');
        fprintf(my_fid, '%s \n', WriteTable{:});
        fclose(my_fid);
    end;

    MyTable=[char(FormattedLabels), num2str(squeeze(sum(BindingCount{1}(:,1:NoMacroVars,3,1),2))/NoMacroVars, '& %1.2f'), ...
        num2str(squeeze(sum(BindingCount{2}(:,1:NoMacroVars,3,1),2))/NoMacroVars, '& %1.2f '), ...
        num2str(squeeze(sum(BindingCount{1}(:,1:NoMacroVars,3,2),2))/NoMacroVars, '& %1.2f'), ...
        num2str(squeeze(sum(BindingCount{2}(:,1:NoMacroVars,3,2),2))/NoMacroVars, '& %1.2f \\\\')];
    if DO_SAVE
%         PreFixName = sprintf('%sNumericalBoundsVariable_Model%1.0f_H%d',save_path_bound, model_version,H);

        my_fid = fopen( [PreFixName '_macro.tex'], 'w');
        WriteTable=cellstr(MyTable);
        WriteTable=regexprep(WriteTable, '>0', '$>0$');
        WriteTable=regexprep(WriteTable, '<0', '$<0$');
        fprintf(my_fid, '%s \n', WriteTable{:});
        fclose(my_fid);
    end;

for ss=1:2
    if ss==1
        PreFixName = sprintf('%sBindingRes_Model%1.0f_H%d',[save_path_bound 'SR_'], model_version,H);
    else
        PreFixName = sprintf('%sBindingRes_Model%1.0f_H%d',[save_path_bound 'HR_'], model_version,H);
    end
    % for TFP only
    for nn = 1:nvar
        display(IncludeSeriesNames{nn});
        if ss==1
        MyTable=([char(FormattedLabels), num2str(squeeze(BindingCount{ss}(:,nn,3,1)), '& %1.2f '), ...
            num2str(squeeze(BindingCount{2}(:,nn,3,1)) , '& %1.2f '), ...
            num2str(squeeze(BindingCount{ss}(:,nn,3,2)), '& %1.2f '), ...
            num2str(squeeze(BindingCount{2}(:,nn,3,2)) , '& %1.2f \\\\ ')]);
        else
        MyTable=([char(FormattedLabels), num2str(squeeze(BindingCount{2}(:,nn,3,1)), '& %1.2f '), ...
            num2str(squeeze(BindingCount{2}(:,nn,3,1))./(squeeze(sum(BindingCount{2}(:,:,3,1),2))/nvar), '& %1.1f '), ...
            num2str(squeeze(BindingCount{2}(:,nn,3,2)), '& %1.2f '), ...
            num2str(squeeze(BindingCount{2}(:,nn,3,2))./(squeeze(sum(BindingCount{2}(:,:,3,2),2))/nvar), '& %1.1f \\\\ ')]);
            
        end;
            if DO_SAVE

                my_fid = fopen( [PreFixName '_' num2str(nn) '.tex'], 'w');
                WriteTable=cellstr(MyTable);
                WriteTable=regexprep(WriteTable, '>0', '$>0$');
                WriteTable=regexprep(WriteTable, '<0', '$<0$');
                fprintf(my_fid, '%s \n', WriteTable{:});
                fclose(my_fid);
            end;
    end;
end

%% Lagrange multipliers
close all
if exist('LagrangeMultipliers','var')

    % LM = cell(2,1);
    % LM{1} = zeros(nres, nvar+1,nstep,9,2);
    % LM{2} = zeros(nres, nvar+1,nstep,9,2);
    % for bb = 1:2
    %     for nn=1:nvar
    %         % 1st: sum incidents over all draws
    %         % 2nd: sum incidents over restriction horizon
    %         LM{2}(:,nn,:,:,bb) = prctile(sum(reshape(squeeze(LagrangeMultipliers.HR( nn, :, :, find(SameIDX), bb)), [nres, H, nstep, sum(SameIDX)]),2), [1 2.5 5 16 50 84 95 97.5 99],4); 
    %         LM{1}(:,nn,:,:,bb) = prctile(sum(reshape(squeeze(LagrangeMultipliers.SR( nn, :, :, find(SameIDX), bb)), [nres, H, nstep, sum(SameIDX)]),2), [1 2.5 5 16 50 84 95 97.5 99],4); 
    %     end;
    %     LM{2}(:,nvar+1,:,:,bb) = prctile(sum(reshape(squeeze(nanmean(LagrangeMultipliers.HR( 1:NoMacroVars, :, :, find(SameIDX), bb),1)), [nres, H, nstep, sum(SameIDX)]),2), [1 2.5 5 16 50 84 95 97.5 99],4); 
    %     LM{1}(:,nvar+1,:,:,bb) = prctile(sum(reshape(squeeze(nanmean(LagrangeMultipliers.SR( 1:NoMacroVars, :, :, find(SameIDX), bb),1)), [nres, H, nstep, sum(SameIDX)]),2), [1 2.5 5 16 50 84 95 97.5 99],4); 
    % end;
    BoxPlotLabels=FormattedLabels;
    BoxPlotLabels=regexprep(BoxPlotLabels, '\$', '');

    BoxPlot_Trial;
end;

%% Acceptance probability under standard algorithm in literature
close all
SameIDX             =~squeeze(isnan(HRimpf_bound(1,1,:,1)));
FontSize=14;
MedianRate= median((1-Empty_Std_Alg_HR(SameIDX,1))*100);
if MedianRate
    FormatString=['Median rate=%1.' num2str(ceil(log10(floor(100/MedianRate)))) 'f'];
else
    FormatString='Median rate=%1.2f';
end;
[yy,xx]=ksdensity((1-Empty_Std_Alg_HR(SameIDX,1))*100, 'Support',[-1e-4, ceil(50*max((1-Empty_Std_Alg_HR(SameIDX,1))*100))/50], 'Function', 'cdf');
plot(xx,yy, 'LineWidth',3)
hold all
plot([1,1]*MedianRate, [0, 0.5], '--k')

text(xx(find(yy>0.5, 1,'first'))*1.1,0.5, [num2str(MedianRate, FormatString), '%'], 'FontSize', FontSize, 'fontWeight', 'normal','FontName','Times New Roman')
set(findall(gcf, '-property', 'FontSize'), 'FontSize', FontSize, 'fontWeight', 'normal','FontName','Times New Roman')
yticks(0:0.1:1)
grid on
xlabel('acceptance probability (%)')
ylabel('cumulative probability')
plot([min(xticks), xx(find(yy<0.5, 1,'last'))],[0.5, 0.5], '--k')
% xticklabels(num2str(xticks'));

if DO_SAVE
    print(gcf, '-depsc', '-r300',sprintf('%sStandardAcceptanceRates_Model%1.0f_H%d_B_narrow.eps',save_path_bound,  model_version,H))
    %         print(gcf, '-dpdf', '-r300',sprintf('%sNumericalBoundsVariable_%d_TD.pdf',save_path_bound,ii))
end
close all

%% FEVD Analysis
if DO_FEVD==2
    FEVD_Analysis;
end;