clear all

ParallelParts=2;
InitialParallelPart=1; 

FileAndPathName = 'Results/FEVD_Results_Model640053_H5_gr' ;
load([FileAndPathName '_Pl' num2str(InitialParallelPart, '%1.0f') '_' num2str(ParallelParts, '%1.0f') ]);

ResultsAll= matfile( ['Results/FEVD_results_all' Suffix '.mat'],'Writable',true);
ResultsAll.HR_FEVD_bound=FEVD_distribution.HR_FEVD_bound;
ResultsAll.SR_FEVD_bound=FEVD_distribution.SR_FEVD_bound;
ResultsAll.HR_FEVD_bound_q=FEVD_distribution.HR_FEVD_bound_q;
ResultsAll.SR_FEVD_bound_q=FEVD_distribution.SR_FEVD_bound_q;

% Now append the other files
for WhichParallelPart=InitialParallelPart+1:ParallelParts 
        CurrentData=load([FileAndPathName '_Pl' num2str(WhichParallelPart, '%1.0f') '_' num2str(ParallelParts, '%1.0f') ]);
                
        ResultsAll.HR_FEVD_bound(:,:,:,CurrentDraws*(WhichParallelPart-1)+(1:CurrentDraws),:)  = CurrentData.FEVD_distribution.HR_FEVD_bound ;
        ResultsAll.SR_FEVD_bound(:,:,:,CurrentDraws*(WhichParallelPart-1)+(1:CurrentDraws),:)  = CurrentData.FEVD_distribution.SR_FEVD_bound ;
        
        ResultsAll.HR_FEVD_bound_q(:,:,:,CurrentDraws*(WhichParallelPart-1)+(1:CurrentDraws),:)  = CurrentData.FEVD_distribution.HR_FEVD_bound_q ;
        ResultsAll.SR_FEVD_bound_q(:,:,:,CurrentDraws*(WhichParallelPart-1)+(1:CurrentDraws),:)  = CurrentData.FEVD_distribution.SR_FEVD_bound_q ;
        
end

clear CurrentData
disp('done');

%%
format bank
% Entries of Table 4.5(a)
% Use that output is first in FEVD_variables

HR_IDX = find(~isnan(squeeze(ResultsAll.HR_FEVD_bound(1, 1, 1, :,2)))); % if this causes any problem below, load ResultsAll from the matfile

disp('entries of Table 4.5(a): median and 68% interval')
prctile(squeeze(ResultsAll.SR_FEVD_bound(1, :, 1, HR_IDX,2))*100, [50 16 86],2)
prctile(squeeze(ResultsAll.HR_FEVD_bound(1, :, 1, HR_IDX,2))*100, [50 16 86],2)
disp('entries of Table 4.5(a): 68% interval of reduction')
prctile(squeeze(ResultsAll.SR_FEVD_bound(1, :, 1, HR_IDX,2))*100-squeeze(ResultsAll.HR_FEVD_bound(1, :, 1, HR_IDX,2))*100, [16 86],2)

% Entries of Table 4.5(b)
disp('entries of Table 4.5(b): 68% interval')
prctile(reshape(ResultsAll.SR_FEVD_bound_q(1, :, 1, HR_IDX,:)*100, length(FEVD_horizons), []), [16 86],2)
prctile(reshape(ResultsAll.HR_FEVD_bound_q(1, :, 1, HR_IDX,:)*100, length(FEVD_horizons), []), [16 86],2)
format short