% Allows to split computations via running multiple Matlab jobs in
% parallel - or one after the other

clear all


ParallelParts=2;
InitialParallelPart=1;

ParallelParts=2;%10;
% tmp_str = '/Results/Results_Model640053_H5_gr' ;
tmp_str = '/Results/Results_Model6490053_H5_gr' ;
load_str = [pwd tmp_str '_Pl' num2str(InitialParallelPart, '%1.0f') '_' num2str(ParallelParts, '%1.0f')];

% Load initial file
load([pwd tmp_str '_Pl' num2str(InitialParallelPart, '%1.0f') '_' num2str(ParallelParts, '%1.0f') ]);

ResultsWoLM = matfile( [regexprep(PreFixName, 'Graphs', 'Results') '_results_wo_LM' Suffix '.mat'],'Writable',true);
ResultsWoLM.HRimpf_bound=HRimpf_bound;
ResultsWoLM.SRimpf_bound=SRimpf_bound;
ResultsWoLM.SIGN_IRFS_SR=SIGN_IRFS_SR;
ResultsWoLM.SIGN_IRFS_HR=SIGN_IRFS_HR;
% be careful to avoid overwriting original file!
if exist('LagrangeMultipliers','var')
    if isobject(LagrangeMultipliers)
        % nothing to do here?
        LagrangeMultipliersAll= matfile( [regexprep(PreFixName, 'Graphs', 'Results') '_LM_all' Suffix '.mat'],'Writable',true);
        if strfind(LagrangeMultipliers.Properties.Source, 'D:')>0
            NewPath = regexprep(LagrangeMultipliers.Properties.Source, 'D:', 'E:');
            LagrangeMultipliers = matfile(NewPath);
        end
        LagrangeMultipliersAll.HR=LagrangeMultipliers.HR;
        LagrangeMultipliersAll.SR=LagrangeMultipliers.SR;
        WriteLM = false;
    else
        LagrangeMultipliersAll= matfile( [regexprep(PreFixName, 'Graphs', 'Results') '_LM_all' Suffix '.mat'],'Writable',true);
        LagrangeMultipliersAll.HR=LagrangeMultipliers.HR;
        LagrangeMultipliersAll.SR=LagrangeMultipliers.SR;
        WriteLM = false;
    end
else
    LagrangeMultipliersAll= matfile( [regexprep(PreFixName, 'Graphs', 'Results') '_LM_all' Suffix '.mat'],'Writable',true);
    LagrangeMultipliersAll.HR = HR;
    LagrangeMultipliersAll.SR = SR;
    
    WriteLM = true;
end

% Now append the other files
for WhichParallelPart=InitialParallelPart+1:ParallelParts 
    CurrentData=load([pwd tmp_str '_Pl' num2str(WhichParallelPart, '%1.0f') '_' num2str(ParallelParts, '%1.0f') ]);

    if WriteLM
        LagrangeMultipliersAll.HR(:,:,:, :, CurrentDraws*(WhichParallelPart-1)+(1:CurrentDraws) ,:) = cat(5,LagrangeMultipliersAll.HR, CurrentData.HR);
        LagrangeMultipliersAll.SR(:,:,:, :, CurrentDraws*(WhichParallelPart-1)+(1:CurrentDraws) ,:) = cat(5,LagrangeMultipliersAll.SR, CurrentData.SR);
    else
        if strfind(CurrentData.LagrangeMultipliers.Properties.Source, 'D:')>0
            NewPath = regexprep(CurrentData.LagrangeMultipliers.Properties.Source, 'D:', 'E:');
            CurrentData.LagrangeMultipliers = matfile(NewPath);
        end            
        LagrangeMultipliersAll.HR(:,:,:, :, CurrentDraws*(WhichParallelPart-1)+(1:CurrentDraws) ,:) = CurrentData.LagrangeMultipliers.HR;
        LagrangeMultipliersAll.SR(:,:,:, :, CurrentDraws*(WhichParallelPart-1)+(1:CurrentDraws) ,:) = CurrentData.LagrangeMultipliers.SR;
    end

    ResultsWoLM.HRimpf_bound(:,:,:,CurrentDraws*(WhichParallelPart-1)+(1:CurrentDraws),:)  = CurrentData.HRimpf_bound ;
    ResultsWoLM.SRimpf_bound(:,:,:,CurrentDraws*(WhichParallelPart-1)+(1:CurrentDraws),:)  = CurrentData.SRimpf_bound ;

    ResultsWoLM.SIGN_IRFS_HR(:,:,:,CurrentDraws*(WhichParallelPart-1)+(1:CurrentDraws),:)  = CurrentData.SIGN_IRFS_HR ;
    ResultsWoLM.SIGN_IRFS_SR(:,:,:,CurrentDraws*(WhichParallelPart-1)+(1:CurrentDraws),:)  = CurrentData.SIGN_IRFS_SR ;
end

clear CurrentData
clear LagrangeMultipliers
LagrangeMultipliers=LagrangeMultipliersAll;
clear LagrangeMultipliersAll

