% Allows to split computations via running multiple Matlab jobs in
% parallel - or one after the other

clear all


ParallelParts=2;
InitialParallelPart=1;
%  Results_Model11200053_H5_gr_NoLam2_Pl1_2
tmp_str = '/Results/Results_Model11200053_H5_gr_NoLam2' ;
Suffix = ['_Pl' num2str(InitialParallelPart, '%1.0f') '_' num2str(ParallelParts, '%1.0f')];
load_str = [pwd tmp_str Suffix];

% Load initial file
load([pwd tmp_str '_Pl' num2str(InitialParallelPart, '%1.0f') '_' num2str(ParallelParts, '%1.0f') ]);

ResultsWoLM = matfile( [pwd regexprep(tmp_str, '_LagrangeM', '') '_results_wo_LM' Suffix '.mat'],'Writable',true);
ResultsWoLM.HRimpf_bound=HRimpf_bound;
ResultsWoLM.SRimpf_bound=SRimpf_bound;
ResultsWoLM.SIGN_IRFS_SR=SIGN_IRFS_SR;
ResultsWoLM.SIGN_IRFS_HR=SIGN_IRFS_HR;
% be careful to avoid overwriting original file!
if exist('LagrangeMultipliers','var')
    if isobject(LagrangeMultipliers)
        % nothing to do here?
        LagrangeMultipliersAll= matfile( [regexprep(PreFixName, 'Graphs', 'Results') '_LM_all' Suffix '.mat'],'Writable',true);
        LagrangeMultipliersAll.HR=LagrangeMultipliers.HR;
        LagrangeMultipliersAll.SR=LagrangeMultipliers.SR;
        WriteLM = false;
    else
        LagrangeMultipliersAll= matfile( [regexprep(PreFixName, 'Graphs', 'Results') '_LM_all' Suffix '.mat'],'Writable',true);
        LagrangeMultipliersAll.HR=LagrangeMultipliers.HR;
        LagrangeMultipliersAll.SR=LagrangeMultipliers.SR;
        WriteLM = false;
    end
else
    LagrangeMultipliersAll= matfile( [regexprep(PreFixName, 'Graphs', 'Results') '_LM_all' Suffix '.mat'],'Writable',true);
    LagrangeMultipliersAll.HR = HR;
    LagrangeMultipliersAll.SR = SR;
    
    WriteLM = true;
end

% check for flawed legacy code with flipped dimensions
FullyBayesian_Size=size(ResultsWoLM.SIGN_IRFS_HR);
if FullyBayesian_Size(4)>FullyBayesian_Size(5) && length(FullyBayesian_Size)==6
    ResultsWoLM.SIGN_IRFS_HR=permute(ResultsWoLM.SIGN_IRFS_HR, [ 1 2 3 5 4 6]);
    ResultsWoLM.SIGN_IRFS_SR=permute(ResultsWoLM.SIGN_IRFS_SR, [ 1 2 3 5 4])  ;
end

% Now append the other files
for WhichParallelPart=InitialParallelPart+1:ParallelParts
    CurrentData=load([pwd regexprep(tmp_str, '_LagrangeM', '') '_Pl' num2str(WhichParallelPart, '%1.0f') '_' num2str(ParallelParts, '%1.0f') ]);
    % check for flawed legacy code with flipped dimensions
    FullyBayesian_Size=size(CurrentData.SIGN_IRFS_HR);
    if FullyBayesian_Size(4)>FullyBayesian_Size(5) && length(FullyBayesian_Size)==6
        CurrentData.SIGN_IRFS_HR=permute(CurrentData.SIGN_IRFS_HR, [ 1 2 3 5 4 6]);
        CurrentData.SIGN_IRFS_SR=permute(CurrentData.SIGN_IRFS_SR, [ 1 2 3 5 4])  ;
    end
    if WriteLM
        LagrangeMultipliersAll.HR(:,:,:, :, CurrentDraws*(WhichParallelPart-1)+(1:CurrentDraws) ,:) = cat(5,LagrangeMultipliersAll.HR, CurrentData.HR);
        LagrangeMultipliersAll.SR(:,:,:, :, CurrentDraws*(WhichParallelPart-1)+(1:CurrentDraws) ,:) = cat(5,LagrangeMultipliersAll.SR, CurrentData.SR);
    elseif nlambdas<=1
        LagrangeMultipliersAll.HR(:,:,:, :, CurrentDraws*(WhichParallelPart-1)+(1:CurrentDraws) ,:) = CurrentData.LagrangeMultipliers.HR;
        LagrangeMultipliersAll.SR(:,:,:, :, CurrentDraws*(WhichParallelPart-1)+(1:CurrentDraws) ,:) = CurrentData.LagrangeMultipliers.SR;
    end
    ResultsWoLM.HRimpf_bound(:,:,:,CurrentDraws*(WhichParallelPart-1)+(1:CurrentDraws),:,:)  = CurrentData.HRimpf_bound ;
    ResultsWoLM.SRimpf_bound(:,:,:,CurrentDraws*(WhichParallelPart-1)+(1:CurrentDraws),:)  = CurrentData.SRimpf_bound ;

    ResultsWoLM.SIGN_IRFS_HR(:,:,:,CurrentDraws*(WhichParallelPart-1)+(1:CurrentDraws),:,:)  = CurrentData.SIGN_IRFS_HR ;
    ResultsWoLM.SIGN_IRFS_SR(:,:,:,CurrentDraws*(WhichParallelPart-1)+(1:CurrentDraws),:)  = CurrentData.SIGN_IRFS_SR ;

end

% save space/memory
clear *AnyR*
clear STD_SIGN*
clear CurrentData
% clear LagrangeMultipliers
% fprintf('Lagrange multipliers cleared!!! \n');
clear LagrangeMultipliersAll

