function [MaxExplained, MinExplained, AllExplained, S, q]=my_summed_forecast_error_cum_q(K, IV_Shock,m_all,NoLags,i,h_min, h_max, Do_Cumulative)

if ~exist('Do_Cumulative', 'var')
    Do_Cumulative=0;
end;

if Do_Cumulative
    % use that \sum_{s=0}^l K^s = (I-K)^{-1} (I-K^(l+1));
    Rli=@(l,i) [zeros(1,i-1), eye(1,m_all*NoLags-(i-1))]* ( (eye(m_all*NoLags)-K) \ (eye(m_all*NoLags)-K^(l+1)) ) * IV_Shock;
else
    Rli=@(l,i) [zeros(1,i-1), eye(1,m_all*NoLags-(i-1))]* K^l * IV_Shock;
end
S=0;
for hh=0:h_max
    % Follow Uhlig (2003)
    S=S+(h_max+1-max(hh,h_min))*Rli(hh,i)'*Rli(hh,i);
end;

[eigs, vals]=eig(S);
SortedVals=sort(diag(vals), 'descend');
MaxExplained=SortedVals(1);
MinExplained=SortedVals(end);
AllExplained=sum(SortedVals);
q=eigs(:,diag(vals)==MaxExplained);