function x_draws = my_tmvn_draw(starting_x, W, n, BurnIn, SampleSize, Skip)
% here: no lower bound and zero upper bound is hard-wired
original_x=starting_x;
trunc_normdraw=@(uni, lb, ub) norminv(uni * (normcdf(ub,0,1)-normcdf(lb,0,1))+normcdf(lb,0,1)); 

x_draws=zeros(n, SampleSize);
for dd=1:(BurnIn+SampleSize)*Skip
    for nn=1:n
        rhs_bound = 1e-12 - W(:,[1:nn-1 nn+1:n])*starting_x([1:nn-1 nn+1:n]);
        POS_IDX=W(:,nn)>0;
        NEG_IDX=W(:,nn)<0;
        upper_bound = min(rhs_bound(POS_IDX) ./W(POS_IDX,nn) );
        lower_bound = max(rhs_bound(NEG_IDX) ./W(NEG_IDX,nn) );
        if isempty(lower_bound)
            lower_bound=-inf;
        end;
        if isempty(upper_bound)
            upper_bound=inf;
        end;
        if upper_bound>lower_bound
%             starting_x(nn)=mvrandn(lower_bound,upper_bound,1,1);
            starting_x(nn) = trunc_normdraw(rand(1,1), lower_bound, upper_bound);
        else
            starting_x(nn)=upper_bound;
        end;
    end;
%     display(norm(starting_x));
    if dd>BurnIn*Skip && (mod(dd-BurnIn*Skip,Skip)==1 || Skip==1)
        x_draws(:,(dd-BurnIn*Skip-1)/Skip+1)=starting_x;
    end;
end;

