function X = rmvnrnd_mdims(N,BurnIn,nvar,ndim,cell_A, x0)


% Check number of input arguments
if nargin<6
    error('please specify all arguments')
end

x_current = x0 ./ repmat(sqrt(sum(x0.^2,1)), nvar,1);
X = zeros(nvar, ndim,N);
try
    for nn = 1:N+BurnIn
        for dd = 1:ndim
            IDX = [1:(dd-1) (dd+1):ndim];
 
                NullKernel=null(x_current(:,IDX)');
        
        x_minus = my_tmvn_draw(NullKernel'*x_current(:,dd) , cell_A{dd}*NullKernel, nvar-ndim+1, 1, 1, 1);
 
            x_current(:, dd)=NullKernel*x_minus;

        end;
        if nn>BurnIn
            X(:,:,nn-BurnIn)=x_current;
        end;
    end;
catch
    x_current = x0 ./ repmat(sqrt(sum(x0.^2,1)), nvar,1);
    X = zeros(nvar, ndim,N);
    try
        for nn = 1:N+BurnIn
            for dd = 1:ndim
                IDX = [1:(dd-1) (dd+1):ndim];
 
                    NullKernel=null(x_current(:,IDX)');
 
            x_minus = rmvnrnd_smpl(1, cell_A{dd}*NullKernel, nvar-ndim+1, NullKernel'*x_current(:,dd) );
 
                x_current(:, dd)=NullKernel*x_minus;

            end;
            if nn>BurnIn
                X(:,:,nn-BurnIn)=x_current;
            end;
        end;
    catch
 
            fprintf(2, 'problem with Algorithm 2 - perhaps restrictions too tight or empty? \n');
 
    end
end;